<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
 <!--
        MSIE | MOZILLA | OPERA
-->
<xsl:param name="browser" select="'MOZILLA'"/>
<xsl:param name="baseURL" select="'/modules/sbm2'"/>
<xsl:param name="baseURL_SUFFIX" select="''"/>
<xsl:param name="skin" select="'/skins/winxp.new.compact'"/>
<xsl:param name="con_help" select="''"/>
<xsl:param name="activeItem" select="'home'"/>
<xsl:param name="reload_left_frame" select="''"/>
<xsl:param name="disable_lock_screen" select="''"/>
<xsl:param name="systemLOGO" select="''"/>
<xsl:param name="heightLOGO" select="''"/>
<xsl:param name="widthLOGO" select="''"/>
<xsl:param name="sid" select="'xxxxxx'"/>
<xsl:variable name="html4.doctype">&#60;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"&#62;</xsl:variable>
<!--<xsl:param name="doctype" >'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" />'</xsl:param>-->
<!--<xsl:param name="doctype">'<'</xsl:param>-->
<xsl:include href="common.xsl"/>
<xsl:include href="pagesets.xsl"/>
<xsl:strip-space elements="*"/>
<xsl:output method="html" indent="yes" encoding="utf-8"/>

<!--
///
-->
<xsl:template match="/">
<xsl:value-of select="$html4.doctype" disable-output-escaping="yes"/>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
		<script language="javascript" type="text/javascript" src="/javascript/common.js"></script>
	    <script language="javascript" type="text/javascript" src="/javascript/chk.js.php"></script>
		<script type="text/javascript" language="javascript" src='{$baseURL}/js/common.js'></script>
		<link rel="stylesheet" type="text/css" href="{$skin}/css/general.css"/>
		<link rel="stylesheet" type="text/css" href="{$skin}/css/main/custom.css"/>
<!--		<link rel="stylesheet" type="text/css" href="{$skin}/css/main/buttons.css"/>-->
		<link rel="stylesheet" type="text/css" href="{$skin}/css/main/layout.css"/>
		<link rel="stylesheet" type="text/nonsense" href="{$skin}/css/misc.css"/>
		<script type="text/javascript" language="javascript">
		<xsl:comment>
		function dc(fl) {
			<xsl:if test="$disable_lock_screen!='true'">
			lon();
			</xsl:if>
		}
		function dc() {
			<xsl:if test="$disable_lock_screen!='true'">
			lon();
			</xsl:if>
		}
		</xsl:comment>
		</script>

		<script type="text/javascript">
		<xsl:comment>

		function _body_onload()
		{
			<xsl:if test="$reload_left_frame='true'">
			refresh_leftframe();
			</xsl:if>
			loff();
			SetContext(&#039;<xsl:value-of select='$con_help'/>&#039;);
			SetHelpModule('sbm2');
			
		}

		function _body_onunload()
		{
			<xsl:if test="$disable_lock_screen!='true'">
			lon();
			</xsl:if>
		}

		var opt_no_frames = false;
		var opt_integrated_mode = false;
		function sbm_form_onkeypress(e)
		{
			var event = e ? e : window.event;
			var target = e ? event.target : event.srcElement;
			var key = event.keyCode;
			
			try {
				if ((13 == key) &amp;&amp; ("text" == target.type)) {
					if(verify(document.forms[0])) {document.forms[0].todo.value = 'save'; document.forms[0].submit();};
					return false;
				}
			} catch (e) {}
			return true;
		}
		
		if (document.layers) document.captureEvents(Event.KEYPRESS);
				document.onkeypress = sbm_form_onkeypress;

		</xsl:comment> 
		</script>
	</head>
<body onLoad="_body_onload();" onUnload="_body_onunload();" id="mainCP">
<xsl:if test="$disable_lock_screen!='true'">
<table border="0" cellspacing="0" cellpadding="0" id="loaderContainer" onClick="return false;"><tr><td id="loaderContainerWH"><div id="loader"><table border="0" cellpadding="0" cellspacing="0" width="100%"><tr><td><p><img src="{$skin}/icons/loading.gif" height="32" width="32" alt=""/><strong>Please wait.<br/>Loading ...</strong></p></td></tr></table></div></td></tr></table>
</xsl:if>
<table width="100%" cellspacing="0" cellpadding="0" border="0"><tr><td id="screenH">
<xsl:apply-templates select="PATHBAR"/>
<xsl:apply-templates select="MODULENAME"/>
<!--<xsl:call-template name="PATHBAR"/>-->
<xsl:apply-templates select="BOOKMARKS"/>
<!--<xsl:call-template name="MODULENAME"/>-->
<!--<xsl:call-template name="BOOKMARKS"/>-->
<xsl:apply-templates/>

<!--<br/><br/><a href="{$baseURL}/index.php?ra_cmd=nocmd">Back</a><br/>
<b><xsl:value-of select="$browser"/></b>-->
</td></tr></table>
</body></html>
</xsl:template>


<xsl:template match="MODULENAME">
	<div class="screenTitle">
		<table width="100%" cellspacing="0">
		<tr>
			<td>
			<xsl:value-of select="."/>
			</td>
			<td class="uplevel">
				<xsl:call-template name="UPLEVEL_TEMPL"/>
			</td>
		</tr>
		</table>
	</div>
</xsl:template>


<xsl:template name="UPLEVEL_TEMPL">
	<div class="commonButton" id="bid-up-level" name="bid-up-level" onmouseover="mouse_move(&#039;sbm_uplevel&#039;)" onmouseout="mouse_move()">
		<xsl:attribute name="title"><xsl:value-of select="//UPLEVEL/@TITLE"/></xsl:attribute>
		<xsl:attribute name="onClick">dc();go_to(&#039;<xsl:value-of select="//UPLEVEL/@ADDRESS"/>&#039;); return false;</xsl:attribute>	 
	<button name="bname_up_level" ><xsl:value-of select="//UPLEVEL/@TITLE"/></button><span><xsl:value-of select="//UPLEVEL/@TITLE"/></span></div> 
</xsl:template>


<xsl:template match="UPLEVEL">
</xsl:template>


<xsl:template match="MAIN-PAGE">
	<div class="screenBody">
	<div class="toolsArea"> 
	<fieldset>
		<legend>Functions</legend>
		<table width="100%" cellspacing="0" cellpadding="0" border="0"><tr><td>
			<div class="screenButtons">
			<table cellspacing="0" cellpadding="10" border="0"><tr><td>
				<xsl:apply-templates select="ICON"/>
			</td></tr></table>
			</div>
		</td></tr></table>
	</fieldset>
	</div>
	</div>
</xsl:template>

<xsl:template match="ICON">
		<style>#bid-sbm-<xsl:value-of select="@ID"/> {background-image: url(<xsl:value-of select="@SRC"/>);}</style>
		<div class="commonButton">
			<xsl:attribute name="id">bid-sbm-<xsl:value-of select="@ID"/></xsl:attribute>	
			<xsl:attribute name="title"><xsl:value-of select="@NAME"/></xsl:attribute>
			<xsl:attribute name="onClick">dc();go_to(&#039;<xsl:value-of select="@ADDRESS"/>&#039;); return false;</xsl:attribute>
			<xsl:attribute name="onmouseover">mouse_move(&#039;<xsl:value-of select="@CON_HELP"/>&#039;)</xsl:attribute>
			<xsl:attribute name="onmouseout">mouse_move()</xsl:attribute>
			
			<button>
				<xsl:attribute name="name">bid-sbm-<xsl:value-of select="@ID"/></xsl:attribute>
				<xsl:value-of select="@NAME"/>
			</button>
			<span>
				<xsl:value-of select="@NAME"/>
			</span>

		</div>		
</xsl:template>


<xsl:template match="BOOKMARKS">
	<div id="screenTabs">
		<div id="tabs">
			<ul>
				<xsl:apply-templates select="MARK"/>
			</ul>
		</div>
	</div>
	<br/>
</xsl:template>

<xsl:template match="MARK">
			<li>
			<xsl:attribute name="onmouseover">mouse_move(&#039;<xsl:value-of select="@CON_HELP"/>&#039;)</xsl:attribute>
			<xsl:attribute name="onmouseout">mouse_move()</xsl:attribute>

			<xsl:if test="@ACTIVE='yes'">
				<xsl:attribute name="id">current</xsl:attribute>
			</xsl:if>
			<xsl:if test="@CLASS">
				<xsl:attribute name="class"><xsl:value-of select="@CLASS"/></xsl:attribute>
			</xsl:if>			
			<a>
				<xsl:attribute name="onClick">document.<xsl:value-of select="../@FORM"/>.action += '&amp;to_tab=<xsl:value-of select="@TAB"/>'; document.<xsl:value-of select="../@FORM"/>.submit();</xsl:attribute>
				
			<span><xsl:value-of select="."/></span>
			</a>
			</li>
</xsl:template>


<xsl:template match="PATHBAR">
	<div class="pathbar">
		<xsl:apply-templates select="ONEPATH"/>
	</div>
</xsl:template>


<xsl:template match="ONEPATH">
	<a onClick="dc();">
		<xsl:attribute name="href"><xsl:value-of select="@PHREF"/></xsl:attribute>
		<xsl:value-of select="."/>
	</a>&#160;&#62;&#160;
</xsl:template>


   
<xsl:template match="PAGE">

<div class="screenBody" >
<xsl:choose>
<xsl:when test="@TITLE">
	<fieldset>
	<legend><xsl:value-of select="@TITLE"/></legend>
	<table width="100%" cellspacing="0" cellpadding="0" border="0"><tr><td>
	<xsl:apply-templates/>
	</td></tr></table>
	</fieldset>
</xsl:when>
<xsl:otherwise>
	<legend><xsl:value-of select="@TITLE"/></legend>
	<table width="100%" cellspacing="0" cellpadding="0" border="0"><tr><td>
	<xsl:apply-templates/>
	</td></tr></table>
</xsl:otherwise>
</xsl:choose>
</div>
</xsl:template>

<xsl:template match="USER-PAGE|FTPHOST-PAGE|SUB-PAGE">
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="ERROR">
<div style="color:red"><xsl:value-of select="."/></div>
</xsl:template>

<xsl:template match="STATUS">
<div class="toolsArea">
	<fieldset>
		<legend>Status</legend>
		<table width="100%" cellspacing="0" cellpadding="0" border="0"><tr><td>
			<xsl:value-of select="@MESSAGE"/>
			<xsl:apply-templates/>
		</td></tr></table>
	</fieldset>
</div>
</xsl:template>

</xsl:stylesheet>
