<?
include_once("common.php");
include_once("config.php");
include_once("modules/pm.php");

function get_domain_id ($ftp_user)
{
	$query = "select `hosting`.`dom_id` from `hosting` left join `sys_users` on `hosting`.`sys_user_id`=`sys_users`.`id` where `sys_users`.`login`='".$ftp_user."';";
	$domain_id = sbm_string_query($query);
	if ($domain_id)
		return $domain_id;
	else
		return false;
}


function RA_show_clients()
{
	global $server;
	if ($_SESSION['user_role'] == 'root' ){
		$dom_id = "";	
	}else
		$dom_id = get_reseller_domain_id($server['username']);
	
	include_once('class.DomainList.php');
	$page = 0;
	$dom_list =new DomainList($server['id']);
	$dom_list->resetError_();

	$res = $dom_list->getPageHeader();
	
	// fetch list
	$dom_list->fetchDomainList($dom_id);
	if ($dom_list->error())
		return false;

	$dom_list->applayFilter_();
	if ($dom_list->error())
		return false;

		$dom_list->applaySort_();
	if ($dom_list->error())
		return false;

	$dom_list->setPageSize($_SESSION['page_size']);
	$page = ($dom_list->filter_ == '')? $_SESSION['page']:0;
	$dom_list->setPage($page);
	$dom_list->applayPage_();	
	
	$res .= $dom_list->get_table();
	$res .= $dom_list->get_bottom();
	
	return $res;

}

function sb_synchronize()
{
	return true;
}

function check_result($result)
{
	global $stat_msg;
	
	if (!$result['CODE']){
		return false;
	}
	
	$license_limits = array('010046', '060002', '060008', '060025', '000002');
	
	$good = array(
		//HOST OK Codes	
		'060004', '060013', '070058', '060009', '060029',
		//SITES OK Codes
		'010041', '010047', '010048', '010056', '010070',
		
		//Resellers OK Codes
		'070003', '070005', '070013' );
	
		if (in_array($result['CODE'], $license_limits)){
				$stat_msg .= lmsg('RA__msg_license_limit').': '.$result['MESSAGE']." ";
				return 1;
		} elseif (in_array($result['CODE'], $good)){
				return 2;
		} else {
			//$stat_msg .= lmsg('RA__msg_err_add_sbhost').": ".$result['MESSAGE'].'. ';
			return 0;
		}

}

function subdomains_allow_access($subdom_list)
{
	include_once('class.sbmDomain.php');
	global $stat_msg;
	global $server;
	if (strpos($subdom_list, ',')) $subdom_list = substr($subdom_list, 0, -1);
	$subdomain_list = split(',' , $subdom_list);
	foreach ($subdomain_list as $subdomain_id) {
		$subdomain = new sbm_SubDomain($subdomain_id);
		$work_dir = ($subdomain->getUserType() == 'main')?'subdomains/'.$subdomain->subdomain_name.'/httpdocs':'httpdocs';
		$subdomain->setWorkDir($work_dir);
		client_allow_access($subdomain);
	}
}
		
function subdomains_deny_access($subdom_list)
{
	include_once('class.sbmDomain.php');
	if (strpos($subdom_list, ',')) 
		$subdom_list = substr($subdom_list, 0, -1);
	$subdomain_list = split(',' , $subdom_list);
	foreach ($subdomain_list as $subdomain_id) {
		$subdomain = new sbm_SubDomain($subdomain_id);
		client_deny_access($subdomain);
	}
}

function domains_allow_access($dom_list)
{
	include_once('class.sbmDomain.php');
	global $stat_msg;
	global $server;
	if (strpos($dom_list, ',')) $dom_list = substr($dom_list, 0, -1);
	$domain_list = split(',' , $dom_list);
	foreach ($domain_list as $domain_id) {
		$domain = new sbm_Domain($domain_id);
		client_allow_access($domain);
	}
		
}

function domains_deny_access($dom_list)
{
	include_once('class.sbmDomain.php');
	if (strpos($dom_list, ','))
		$dom_list = substr($dom_list, 0, -1);
	$domain_list = split(',' , $dom_list);
	foreach ($domain_list as $domain_id) {
		$domain = new sbm_Domain($domain_id);
		client_deny_access($domain);
	}
		
}

function client_allow_access($domain = NULL)
{
//	$domain = new sbm_Domain(0);
	global $stat_msg;
	global $server;
	if (!$domain || $domain->isAllowed()){
		return;
	}
//var_dump($domain);	
	$result = add_sb_host($domain->getIPAddress());
	if (!$result) {
		return;
	}

	$params = array (
		'sb_server_user'=> $domain->sb_server['username'],
		'site_id' 		=> $domain->getSiteAlias(),
		'ip_address'	=> $domain->getIPAddress(),
		'domain_name'	=> $domain->getHostname(),
		'ftp_login' 	=> $domain->getFtpLogin(),
		'ftp_password'	=> $domain->getFtpPasswd(),
		'work_dir'		=> $domain->getWorkDir(),
		'reseller'		=> $domain->sb_server['username'],
	);

	if ($result = add_sb_site($params)){
		$site_id = $result->result->get_content();
		if ($site_id != ""){
			if (get_class($domain) == "sbm_Domain") { //Add custom buttons only for domains
				$url = "/modules/sbm2/open_sb.php?sb_server=".substr($domain->sb_server['name'], 0, strpos($domain->sb_server['name'],'remote_admin/')).'&siteid='.$site_id."&pswd=".$domain->getFtpPasswd();
				cb_clean($domain->getID(), $url);
				$prefix = (isset($_SERVER['HTTP_HOST'])) ? "https://".$_SERVER["HTTP_HOST"] : "https://".get_param('FullHostName').":8443";
				cb_icon_create($domain->getId(),  $prefix.$url, $domain->sb_server['username']);
			}
			$domain->setAttribute("site_owners", array($server['username'] => $site_id));
			$domain->add_tbl_record($server['username']);
		}
	} else {
		$stat_msg .= lmsg('RA__msg_err_add_domain')."'".$domain->getHostname()."'. ";
	}
}

function client_deny_access($domain)
{

	if (!$domain || !$domain->isAllowed()){
		return;
	}
	$url = "/modules/sbm2/open_sb.php?sb_server=".substr($domain->sb_server['name'], 0, strpos($domain->sb_server['name'],'remote_admin/')).'&siteid='.$domain->getSiteID()."&pswd=".$domain->getFtpPasswd();
	cb_clean($domain->getID(), $url);
	delete_sb_site($domain->getSiteID());
	$domain->remove_tbl_record();		
}


function sbm_set_site_parameters($params = NULL){
	if (is_null($params))
		return false;
	
	$root_login = sbm_get_root_login();
	$base_plan = sbm_get_base_plan();

	$post = array(
		'sb_site_type'	=>	'REGULAR',
		'sb_siteid'	=>	$params['site_id'],
		'sb_active'	=>	1,
		'sb_plan'	=>	$base_plan,
		'sb_pswd'	=>	$params['ftp_password'],
		'sb_pswd_conf'	=> $params['ftp_password'],
		'sb_publish'	=>	1,
		'sb_host_name'	=> $params['domain_name'],
		'sb_mode'	=>	'ftp',
		'sb_ftp_host'	=>	$params['ip_address'],
		'sb_ftp_login'	=>	$params['ftp_login'],
		'sb_ftp_pass'	=>	$params['ftp_password'],
		'sb_ftp_workdir'	=>	$params['work_dir'],
		'PlanHost'	=>	$params['ip_address'],
	);
	
	if (isset($params['sb_old_siteid'])) //Update case only - required parameter;
		$post = array_merge($post, array('sb_old_siteid' => $params['sb_old_siteid']));
	
	return $post;
}

function add_sb_site($params = NULL, $cmd = 'create_site')
{
	if (is_null($params) || !in_array($cmd, array('create_site', 'update_site')))
		return false;
	
	global $stat_msg;		
	if ($post = sbm_set_site_parameters($params)){
		$site = new RA_Sites();
		$site->send_command($cmd, $post);
	
		if ($site->error()){
			$cmd = check_result($site->error());
			if ($cmd == 0 || $cmd == 1){
				$stat_msg .= lmsg('RA__msg_err_add_sbsite')." '".$params['site_id']."': ".$site->error['MESSAGE']." ";
				return false;
			}
		}
		return $site;
	} else 
		return false;

}

function add_sb_host($hostname)
{
	global $stat_msg;	
	$host = new RA_Hosts();
	if ($hostname == ""){
		$host->error['MESSAGE'] = "Empty hostname.";
	} else {
		$attr = &$host->data[NEW_ID];
		$attr['HOST_NAME'] = $hostname;
		$attr['ACTIVE']	= 1;
		$host->add(NEW_ID);
	}
	
	if ($host->error()){
		$cmd = check_result($host->error());
		if ($cmd == 0 || $cmd == 1){
			$stat_msg .= lmsg('RA__msg_err_add_sbhost')." '$hostname': ".$host->error['MESSAGE']." ";
			return false;
		}
	}

	return $host;
}

function delete_sb_site($site_id= '')
{
	global $stat_msg;
	$site = new RA_Sites();
	if ($site_id == '') {
		$site->error['MESSAGE'] = "Empty site alias";
	} else {
		$site->delete($site_id);
	}
    
	if ($site->error()){
		$stat_msg .= lmsg('RA__msg_err_del_sbsite')." '$site_id': ".$site->error['MESSAGE']." ";
		return false;
	}
	return true;
}

function delete_sb_host($hostname)
{
	$host = new RA_Hosts();
	$host->delete($hostname);
    return $host;
}

function cb_icon_create($domain_id, $url, $owner = '')
{

//	$cb_tool = PRODUCT_ROOT."/bin/custombutton.sh";
//	$cmd = "$cb_tool --create -owner \"$dom_name\" -place \"domain\" -text \"SiteBuilder2 (Access for: $owner)\" -url \"$url\" -conhelp \"SiteBuilder2\" -file $img_path";
//	return msg_exec($cmd);
	$img_path = PRODUCT_ROOT.'/admin/htdocs/modules/sbm2/images/icon.gif';
	
	if (!class_exists('pm_CustomButton')) {
		require_once('class.CustomButton.php');
		$custom_button = objectMaker('CustomButton', 0);
	} else 
		$custom_button = objectMaker('pm_CustomButton',0);
	
	$custom_button->setConhelp('SiteBuilder2');
	$custom_button->setText("SiteBuilder2 (Access for: $owner)");
	$custom_button->setUrl($url);
	$custom_button->setLevel(IS_DOMAIN_OWNER);
	$custom_button->setLevelID($domain_id);
	$custom_button->setPlace("domain");
	$custom_button->setFile($img_path);

	$custom_button->update();
	if ($custom_button->error()){
		return false;
	}

	return $custom_button->getId();

}

function cb_clean($dom_id, $url)
{
	global $stat_msg;
//	$cb_tool = PRODUCT_ROOT."/bin/custombutton.sh";
	if (strpos($url, "&pswd")){
		$url = substr($url, 0, strpos($url, "&pswd"));
		$url = str_replace("_", "\_", $url);
		$url = str_replace("%", "\%", $url);
		$query = "SELECT `id` FROM `custom_buttons` WHERE `level_id` = '$dom_id' AND `url` LIKE '%$url%';";
	} else {
		$query = "SELECT `id` FROM `custom_buttons` WHERE `level_id` = '$dom_id' AND `url` = '$url';";
	}

	$res = db_query($query);
	while (list($cb_id) = mysql_fetch_row($res)){
		if (!class_exists('pm_CustomButton')) {
			require_once('class.CustomButton.php');
			$myCustomButton = objectMaker('CustomButton', $cb_id);
		} else {
			$myCustomButton = objectMaker('pm_CustomButton',$cb_id);
		}

		$myCustomButton->delete();

		if ($myCustomButton->error()){
			return false;
		}
	}
	return true;
}


?>
