<?

class sbm_BaseDomain
{
	var $id;
	var $domain_name;
	var $displayName;
	var $ip_address;
	var $ftp_login;
	var $ftp_password;
	var $site_alias;
	var $site_url;
	var $sb_server = array();
	var $work_dir = 'httpdocs';
	var $site_owners = array(); //Stores site owners (resellers)
	
	function sbm_BaseDomain($id = 0) {
		global $server;
		$this->setID($id);
		$this->sb_server = $server;
	}
	
	function isAllowed()
	{
		return array_key_exists($this->sb_server['username'], $this->site_owners);
	}

	function fetchSiteAlias()
	{
		$this->site_alias = str_replace(array('.', '@',':','_'), '-', $this->sb_server['username']."-".$this->domain_name."-site");
	}
	
	function setID($id = 0){
		$this->id = $id;
	}
	
	function setWorkDir($workdir = ""){
		$this->work_dir = $workdir;
	}

	function setAttribute($attr_name = "", $attr_value = "")
	{
		if (!$attr_name){
			return;
		}
		
		$this->$attr_name = $attr_value;
	}
	
	function getAttribute($attr_name = "")
	{
		if (!$attr_name || !isset($this->$attr_name)){
			return false;
		}
		return $this->$attr_name;
	}
	
	function getID()
	{
		return $this->getAttribute("id");
	}

	function getHostname()
	{
		return $this->getAttribute("domain_name");
	}

	function getDisplayName()
	{
		return $this->getAttribute("displayName");
	}

	function getIPAddress()
	{
		return $this->getAttribute("ip_address");
	}

	function getFtpLogin()
	{
		return $this->getAttribute("ftp_login");
	}

	function getFtpPasswd()
	{
		return $this->getAttribute("ftp_password");
	}
	
	function getSiteID($owner = '')
	{
		$owner = ($owner == '') ? $this->sb_server['username'] : $owner;
		return $this->site_owners[$owner];
	}

	function getSiteAlias()
	{
		return $this->getAttribute("site_alias");
	}

	function getWorkDir()
	{
		return $this->getAttribute("work_dir");
	}
	
	function remove_tbl_record()
	{
		$query = "DELETE FROM `".RA_TBL_DOMAINS."` WHERE `site_identity`='".$this->getSiteID()."' AND `sb_server_id` = '".$this->sb_server['id']."';";
		db_query($query);
	}

}

class sbm_Domain extends sbm_BaseDomain
{
	function sbm_Domain($id=0)
	{
		sbm_BaseDomain::sbm_BaseDomain($id);
		$this->fetchDetails();
	}
	
	function fetchDetails()
	{
		if (!$this->id){
			return;
		}
		$this->fetchDomainName();
		$this->fetchDomainDisplayName();
		$this->fetchIPAddress();
		$this->fetchFtpLogin();
		$this->fetchFtpPasswd();
		$this->fetchSiteIDs();
		$this->fetchSiteAlias();
	}
		
	function fetchDomainName()
	{
		$query = 'SELECT `name` FROM `domains` WHERE `id`=\''.$this->id.'\';';
		$this->domain_name = sbm_string_query($query);
	}

	function fetchDomainDisplayName()
	{
		$query = 'SELECT `displayName` FROM `domains` WHERE `id`=\''.$this->id.'\';';
		$this->displayName = sbm_string_query($query);
	}
	
	function fetchIPAddress()
	{
		$query = "SELECT `ip_address` FROM `IP_Addresses` LEFT JOIN `hosting` ON `hosting`.`ip_address_id` = `IP_Addresses`.`id` WHERE `hosting`.`dom_id` = '".$this->id."';";
		$this->ip_address = sbm_string_query($query);
	}
	
	function fetchFtpLogin()
	{
		$query = 'SELECT `login` FROM `sys_users` LEFT JOIN `hosting` ON `sys_users`.`id`=`hosting`.`sys_user_id` WHERE `hosting`.`dom_id`=\''.$this->id.'\';';
		$this->ftp_login = sbm_string_query($query);
	}
	
	function fetchFtpPasswd()
	{
		$query = 'SELECT `accounts`.`password` FROM `accounts` LEFT JOIN `sys_users` ON `sys_users`.`account_id`=`accounts`.`id`  LEFT JOIN `hosting` ON `sys_users`.`id`=`hosting`.`sys_user_id` WHERE `hosting`.`dom_id`=\''.$this->id.'\';';
		$this->ftp_password = sbm_string_query($query);
	}
	
	function fetchSiteIDs()
	{
		$query = "SELECT `site_identity`, `site_owner` FROM `".RA_TBL_DOMAINS."`  WHERE `domain_id`='".$this->id."' AND `sb_server_id` = '".$this->sb_server['id']."';";
		$res = db_query($query);
		while (list ($site_id, $site_owner) = mysql_fetch_row($res)){
			$this->site_owners[$site_owner] = $site_id;
		}
	}

	function add_tbl_record(){
		$this->remove_tbl_record();
		$query = "INSERT INTO `".RA_TBL_DOMAINS."` SET `domain_id`='".$this->id."', `subdom_id`=0, `site_identity`='".$this->getSiteID()."', `sb_server_id` = '".$this->sb_server['id']."', `site_owner` = '".$this->sb_server['username']."';";
		$res .= db_query($query);
		return $res;
	}

}

class sbm_SubDomain extends sbm_BaseDomain
{
	var $domain_id;
	var $subdomain_name;
	var $dom_name;
	var $usertype;
	
	function sbm_SubDomain($id=0)
	{
		sbm_BaseDomain::sbm_BaseDomain($id);
		$this->fetchDetails();
	}
	
	function fetchDetails()
	{
		if (!$this->id){
			return;
		}
		$this->fetchSubdomainDetails();
		$this->fetchFtpDetails();
		$this->fetchIPAddress();
		$this->fetchSiteIDs();
		$this->fetchSiteAlias();
	}
		
	function fetchSubdomainDetails()
	{
		$query = 'SELECT `subdomains`.`name`, `subdomains`.`sys_user_type`, `subdomains`.`dom_id`, `domains`.`name` FROM `subdomains` LEFT JOIN `domains` on `subdomains`.`dom_id` = `domains`.`id` WHERE `subdomains`.`id`=\''.$this->id.'\';';
		$res = db_query($query);
		list($this->subdomain_name, $this->usertype, $this->domain_id, $this->dom_name) = mysql_fetch_row($res);
		$this->domain_name = $this->subdomain_name.".".$this->dom_name;
	}
	
	function fetchIPAddress()
	{
		$query = "SELECT `ip_address` FROM `IP_Addresses` LEFT JOIN `hosting` ON `hosting`.`ip_address_id` = `IP_Addresses`.`id` WHERE `hosting`.`dom_id` = '".$this->domain_id."';";
		$this->ip_address = sbm_string_query($query);
	}
	
	function fetchFtpDetails()
	{
		$query = 'SELECT `sys_users`.`login`, `accounts`.`password` FROM `sys_users` LEFT JOIN `subdomains` ON `sys_users`.`id`=`subdomains`.`sys_user_id` LEFT JOIN `accounts` on `sys_users`.`account_id` = `accounts`.`id` WHERE `subdomains`.`id`=\''.$this->id.'\';';
		$res = db_query($query);
		list ($this->ftp_login, $this->ftp_password) = mysql_fetch_row($res);
	}
	
	function fetchSiteIDs()
	{
		$query = "SELECT `site_identity`, `site_owner` FROM `".RA_TBL_DOMAINS."`  WHERE `subdom_id`='".$this->id."' AND `sb_server_id` = '".$this->sb_server['id']."';";
		$res = db_query($query);
		while (list ($site_id, $site_owner) = mysql_fetch_row($res)){
			$this->site_owners[$site_owner] = $site_id;
		}
	}

	function add_tbl_record(){
		$this->remove_tbl_record();
		$query = "INSERT INTO `".RA_TBL_DOMAINS."` SET `subdom_id`='".$this->id."', `domain_id`=0, `site_identity`='".$this->getSiteID()."', `sb_server_id` = '".$this->sb_server['id']."', `site_owner` = '".$this->sb_server['username']."';";
		$res .= db_query($query);
		return $res;
	}

	function getUserType()
	{
		return $this->getAttribute("usertype");
	}

	function getParentHostname()
	{
		return $this->dom_name;
	}
	
	
}
?>