<?

class ctlForm
{
	var $name = DEFAULT_FORM;
	var $action = POST_HANDLER;
	var $todo;
	
	function ctlForm($data = null, $fields = null)
	{
		$this->data = $data;
		
		$this->fields = $fields;
	}
	
	function getAction()
	{
		$action = $this->action . "?";
		if(is_array($_GET)) 
		{
			foreach ($_GET as $key => $val) $action .= $key . "=" . urlencode($val) . "&amp;";
		}
		return $action;
	}
	
	function value($key = null)
	{
		if(is_null($key) || !isset($this->data[$key])) return null;
		else return $this->data[$key];
	}
	
	function toxml()
	{
		$res  = '<PAGE><FORM ACTION="'.$this->getAction().'" NAME="'.$this->name.'"';
		if(is_array($this->fields)){
			foreach ($this->fields as $key => $val)
				if(isset($val['required'])&&$val['required']){
					$res .= ' REQUIRED="1"';
					break;
				}
		}
		$res .= '>';

		if($this->addScript()) $res .= "<SCRIPT>".$this->addScript()."</SCRIPT>";

		$res .= '<HIDDEN ID="do" NAME="todo" VALUE="'.$this->todo.'"/>';

		$res .= $this->addFields();		

		$res .= $this->addTabs();
		
		$res .= $this->addSaveButtons();
		

		$res .= '</FORM></PAGE>';
		return $res;
	}
	
	function addSaveButtons()
	{
		$res.='<BUTTON ID="bid-ok" name="bname_ok" CAPTION="'.lmsg('RA__btn_save').'" ONCLICK="if(verify('.$this->name.')) {document.'.$this->name.'.todo.value = \''.SAVE.'\'; document.'.$this->name.'.submit();}"/>';
		$res.='<BUTTON ID="bid-cancel" name="bname_cancel" CAPTION="'.lmsg('RA__btn_cancel').'" ONCLICK="document.'.$this->name.'.todo.value = \''.CANCEL.'\'; document.'.$this->name.'.submit();"/>';
		
		return $res;
	}
	
	function addScript($script = "")
	{
		$str = "";
		$at_least_one_required = false;
		foreach ($this->fields as $key => $val)
		{
			if($val['required'])
			{
				$at_least_one_required = true;
				$str .= "if(document." . $this->name . "." . $key . ".value == '') { alert('".$val['caption']." is required.'); return false;}";
			}
		}

		$str = sprintf("function verify() {if (form_check_password(document.forms[0]) == false) {return false}; \n%s\n%s\nreturn true;}", $str, $script);

		return $str;
	}
	
	function addTabs($PageList = null, $current = GENERAL)
	{
		if(!is_null($PageList)){
			if(is_null($current)) $current = $this->getTab();
			$str ="<TABS FORM=\"".$this->name."\">";
			$i=1;	
			foreach ($PageList as $key => $val)
				{
				$str.="<TAB";
				if ($key==$current)
					$str.=" ACTIVE=\"yes\"";
				$str.=" NAME=\"".$key."\"";
				if ($i==1) $str.=" CLASS=\"first\"";
				if ($i==count($PageList)) $str.=" CLASS=\"last\"";
				$str.=">".$val."</TAB>";
				$i++;
				}
			$str.="</TABS>";
			return $str;
		} else
			return "";
	}
	
	function addFields()
	{
		if(is_array($this->fields)) 
		{
			foreach ($this->fields as $key => $val)
			{
				if($val['disabled'])
				{
					$name = $key;// . '_';
//					if($this->value($key))
//					{
//						$res .= '<HIDDEN ID="'.$key.'" NAME="'.$key.'" VALUE="'.$this->value($key).'"/>';
//					}
				}
				else
				{
					$name = $key;
				}
				
				switch ($val['type'])
				{
					case LABEL :
						$res.='<FIELD NAME="'.$name.'" TITLE="'.$val['caption'].'" TYPE="textdata" VALUE="'.$this->value($key).'"/>';
					break;
					
					case TEXT :
						$res.='<FIELD NAME="'.$name.'" TITLE="'.$val['caption'].'" TYPE="text" VALUE="'.$this->value($key).'" ';
						if($val['disabled']) $res .= ' DISABLED="true"'; 
						if($val['required']) $res .= ' REQUIRED="1"';
						$res.='/>';
					break;
					
					case CHECKBOX :
						$res.= '<FIELD TYPE="check" VALUE="1" TITLE="'.$val['caption'].'" NAME="'.$name.'_ch" '. ($this->value($key) ? 'CHECKED="true"' : '');
						if($val['disabled']) $res .= ' DISABLED="true"'; 
						if($val['required']) $res .= ' REQUIRED="1"';
						$res .= ' ONCLICK="'.sprintf("document.%s.%s.value = document.%s.%s_ch.checked ? 1 : 0;", 
												$this->name, $name, $this->name, $name).
								'"';
						$res.='/>';
						$res .= '<HIDDEN ID="'.$key.'" NAME="'.$name.'" VALUE="'.$this->value($key).'"/>';
					break;						
					
					case SELECT :
						$res.= '<FIELD NAME="'.$name.'" TITLE="'.$val['caption'].'" TYPE="list"';
						if($val['onchange']) $res .= ' ONCHANGE="'.$val['onchange'].'"';
						if($val['disabled']) $res .= ' DISABLED="true"'; 
						if($val['required']) $res .= ' REQUIRED="1"';						
						$res.='>';

						if(is_array($val['list']))
						{
							if($this->value($key) && !array_key_exists($this->value($key), $val['list']))
							{
								$res.='<ITEM SELECTED="1" VALUE="'.$this->value($key).'">'.$this->value($key).'</ITEM>';
							}
							foreach ($val['list'] as $id => $item)
							{
								$res .= '<ITEM VALUE="'.$id.'"';
									if ($id == $this->value($key)){
										$res .= ' SELECTED="1"';
									}
									$res .= '>'.$item.'</ITEM>';
							}
						}
						else 
						{
							$res.='<ITEM SELECTED="1" VALUE="'.$this->value($key).'">'.$this->value($key).'</ITEM>';
						}							
						$res.= '</FIELD>';
					break;
					
					case PASSWORD :
						$res.='<FIELD NAME="'.$name.'" TITLE="'.$val['caption'].'" TYPE="pswd"';
						if($val['disabled']) $res .= ' DISABLED="true"';
						if($val['required']) $res .= ' REQUIRED="1"';
						$res .= ' VALUE="'.$this->value($key).'"/>';
					break;
					
					default:
						$res.='<FIELD NAME="'.$name.'" TITLE="'.$val['caption'].'" TYPE="text" VALUE="'.$this->value($key).'"';
						if($val['disabled']) $res .= ' DISABLED="true"';
						if($val['required']) $res .= ' REQUIRED="1"';						
						$res .= '/>';
				}
			}
		}
		else 
		{
			foreach ($this->data as $key => $val)
			{
				$res.='<FIELD NAME="'.$key.'" TITLE="'.$key.'" TYPE="text" VALUE="'.$val.'"/>';
			}
		}
		return $res;
	}
	
	function getTab()
	{
		return null;
	}
}

// this form can disabled all filds and be of read only type
// it's related from flag $this->ReadOnly
class ctlReadonlyForm extends ctlForm 
{
	var $readonly = false;
	
	function ctlReadonlyForm($data, $fields)
	{
		if($this->readonly) 
		{
			foreach ($fields as $key => $val)
			{
				$fields[$key]['disabled'] = true;
			}
		}
		parent::ctlForm($data, $fields);
	}
	
	function addSaveButtons()
	{
		if($this->readonly)
		{
			$res.='<BUTTON ID="bid-ok" name="bname_cancel" CAPTION="'.lmsg('RA__btn_ok').'" ONCLICK="document.'.$this->name.'.todo.value = \''.CANCEL.'\'; document.'.$this->name.'.submit();"/>';
		}
		else
		{
			$res = parent::addSaveButtons();
		}
		
		return $res;
	}
}

?>