<?
define('CLIENTSLIST_MODE_EDIT', 1);
define('CLIENTSLIST_MODE_SELECT', 2);

//include_once('class.cList.php3');

class ctlBaseList
{
	var $no_links = false;
	var $filter_on = null;
	
	function ctlBaseList($action = '', $form = DEFAULT_FORM)
	{
		$this->form = $form;
		if(!$action) $this->action = '/';
		else $this->action = $action;
	}
	
	function getAction()
	{
		$action = $this->action . "?";
		if(is_array($_GET)) 
		{
			foreach ($_GET as $key => $val) $action .= $key . "=" . $val . "&amp;";
		}
		return $action;
	}

	function setCaption($caption)
	{
		$checkcaption = '';
		
		$first = array(
			'number' => array('caption' => lmsg('__N'), 'type' => 'handler', 'handler' => 'Number'),
			'checkbox' => array('caption' => $checkcaption, 'type' => 'handler', 'handler' => 'Checkbox')
		);
		$this->fields = array_merge((array)$first, (array)$caption);
	}

	function setData($data)
	{
		$this->getAction();
		$this->filterData($data);
		$this->sortData($data);		
		$this->pagingData($data);
		$this->list = $data;
	}

	function setFilterOn($filter_on = null)
	{
			if(is_null($this->filter_on) && is_null($filter_on))
			{
				$keys = array_keys($this->fields);
				$this->filter_on = $keys[3];
			}
			elseif(!is_null($filter_on))
			{
				$this->filter_on = $filter_on;
			}
	}
	
	function filterData(&$data)
	{
		$this->setFilterOn();		
		$filter = &$_SESSION['filter'][get_class($this)];
		if(isset($filter) && $filter !=="" && is_array($data))
		{
			$this->filter = $filter;
			$data = array_filter($data, array($this, 'filter'));
		}
	}
	
	function filter($a)
	{
		if(stripos($a[$this->filter_on], $this->filter) !== false) return true;
		else return false; 
	}
	
	function pagingData(&$data)
	{
		$paging = &$_SESSION['paging'][get_class($this)];
		if(is_array($data))
		{
			$this->size = sizeof($data);
			$this->page_size = $paging['page_size'] > 0 ? $paging['page_size'] : 10;			
			$this->page = min($paging['page'], floor($this->size / $this->page_size));

			$i=0;
			foreach ($data as $key => $val)
			{
				if($i < $this->page * $this->page_size) unset($data[$key]);
				elseif($i >= ($this->page + 1) * $this->page_size) unset($data[$key]);
				$i++;
			}
		}
	}
	
	function sortData(&$data)
	{
		if(is_array($_SESSION['sort'][get_class($this)]) && is_array($data))
		{
			$i = 1;
			foreach ($_SESSION['sort'][get_class($this)] as $key => $val)
			{
				if(isset($this->fields[$key])) {
					if($i++ == 1)
					{
						$this->fields[$key]['SORTBY'] = true;
						$this->fields[$key]['DIR'] = ($val == ASC ? 'asc' : 'desc');
					}
					$this->sort[$key] = $val;
				}
			}
			if(!uasort($data, array($this, 'sort'))) set_error(array('MESSAGE' => 'Error occurs while sorting ' . get_class($this)));
		}
	}
	
	function sort($a, $b)
	{
		if($a == $b) return 0;
		foreach ($this->sort as $key => $val)
		{
			if($a[$key] == $b[$key]) continue;
			if($val == DESC)
			{
				return $a[$key] < $b[$key];
			}
			elseif($val == ASC)
			{
				return $b[$key] < $a[$key];
			}
		}
	}
	
	function _get($key)
	{
		return $this->list[$this->row][$key];
	}

	function get($key)
	{
		$get_method = 'get' . $key;
			if(isset($this->fields[$key]['handler']))
			{
				return $this->{$this->fields[$key]['handler']}();
			}
			elseif(method_exists($this, $get_method) && $key != '')
			{
				return $this->$get_method();
			}
			else 
			{
				return $this->list[$this->row][$key];
			}
	}

	function link($key)
	{
		$get_method = 'link' . $key;
			if(method_exists($this, $get_method) && $key != '')
			{
				return $this->$get_method();
			}
			else 
			{
				return null;
			}
	}
	
	function is_link($key)
	{
		return (method_exists($this, $get_method) && $key != '') && !$this->no_links;
	}
	
	function number()
	{
		static $n = null;
		if(is_null($n)) $n = $this->page * $this->page_size + 1;
		return $n++;
	}
	
	function checkbox()
	{
		return '<CHECK NAME="sb_cc_obj_ids" VALUE="'.$this->id().'"'. ($this->is_disabled() || $this->checkbox_is_disabled() ? ' DISABLED="true" ' : '') .'/>';
	}
	
	function is_disabled()
	{
		return false;
	}
	
	function checkbox_is_disabled()
	{
		return false;
	}
	
	function getACTIVE()
	{
		return $this->_get('ACTIVE') ? 'A' : 'D';
	}
	
	function addHeadButtons()
	{
		$res .= '<SEARCH-FIELD NAME="to_search" CAPTION="'.lmsg('bt_search').': '.$this->fields[$this->filter_on]['caption'].'" VALUE="'.stripslashes(htmlspecialchars($this->filter)).'"/>';
		$res .= '<SEARCH-BUTTON CAPTION="'.lmsg('bt_search').'" ONCLICK="dc(1); document.'.$this->form.'.action += \'to_filter_list='. get_class($this) .'&amp;\'; document.'.$this->form.'.sb_cc_search_button.value=1;document.'.$this->form.'.submit();"/>';
		$res .= '<BUTTON NAME="admin_show" CAPTION="'.lmsg('bt_show_all').'" ONCLICK="dc(1); document.'.$this->form.'.to_search.value = \'\'; document.'.$this->form.'.action += \'to_filter_list='. get_class($this) .'&amp;\'; document.'.$this->form.'.sb_cc_search_button.value=1;document.'.$this->form.'.submit();"/>';
		return $res;
	}
	
	function TopPanel()
	{
		$res .= '<TOP-PANEL>';
		$res .= $this->addHeadButtons();
		$res .= '</TOP-PANEL>';
		return $res;
	}
	
	function toxml()
	{
			$res .= '<PAGE><ENTITYLIST NAME="'.$this->form.'" ACTION="'.$this->getAction().'">';
			$res .= '<LOCALE NAME="MSG_NOTHING_SELECTED_ITEMS" VALUE="No items selected"/>';
			$res .= '<LOCALE NAME="MSG_CANNOT_DELETE_ALL" VALUE="Cannot delete all languages"/>';
//			$res .= '<REMARK>A - Access allowed, D - Access denied </REMARK>';
			$res .=	$this->TopPanel();
			$res .= '<HIDDEN ID="sb_cc_search_button" NAME="sb_cc_search_button" VALUE=""/>';
			$res .='<HIDDEN ID="id_activate" NAME="id_activate" VALUE=""/>';
			$res .='<HIDDEN ID="com" NAME="com" VALUE=""/>';
			$res .='<HEAD>';
			/*	
			*/
			foreach ($this->fields as $key => $item)
			{
				if($key == 'number')
				{
					$res .='<HEAD-ITEM WIDTH="1" ALIGN="CENTER">N</HEAD-ITEM>';
				}
				elseif($key == 'checkbox')
				{
					$res .='<HEAD-ITEM WIDTH="1" ALIGN="CENTER">';
					$res .='<CHECK VALUE="" ONCLICK="doSelectForDel(this)"/>';
					$res .='</HEAD-ITEM>';
				}
				else
				{
					$res .='<HEAD-ITEM  CAPTION="'.$item['caption'].'"';
					if($item['SORTBY']) $res .= ' SORTBY="true" DIR="'.$item['DIR'] . '"';
					if(isset($item['align'])) $res .=' ALIGN="'.$item['align'].'"';
					$res .= '>';
					$res .='<ACTION>'.$this->getAction().'to_sorl='.get_class($this).'&amp;to_sort='.$key.'&amp;</ACTION>';
					$res .='</HEAD-ITEM>';
				}
			}
			$res .='</HEAD>';
			if(is_array($this->list))
			{

				foreach ($this->list as $this->row => $item)
				{
					$res.= '<ENTITY ENABLED="true">';
					foreach ($this->fields as $key => $field)
					{
						switch($field['type'])
						{
							case 'id' :
								$res.= '<ENTITY-ITEM ALIGN="CENTER">';
								$res.= '<CHECK VALUE="'.$domain['id'].'" NAME="sb_cc_obj_ids[]"/>';
								$res.= '</ENTITY-ITEM>';
							break;
			
							case 'handler' :
								$res.= '<ENTITY-ITEM ALIGN="CENTER">';
								$res.= $this->get($key);
								$res.= '</ENTITY-ITEM>';
							break;
							
							case 'link' :
								if(!$this->no_links && !$this->is_disabled())
								{
									$res.= '<ENTITY-ITEM ALIGN="LEFT" CAPTION="'.$this->get($key).'">';
									$res.= '<ACTION>' . $this->link($key) .'</ACTION>';
									$res.= '</ENTITY-ITEM>';
								}
								else
								{
									$res.= '<ENTITY-ITEM ALIGN="LEFT">';
									$res.= $this->get($key);
									$res.= '</ENTITY-ITEM>';
								}
							break;
	
							case 'check' :
								$res.= '<ENTITY-ITEM ALIGN="CENTER" CAPTION="'.$checked.'">';
								$res.= '<BUTTON CAPTION="'.$checked.'" ONCLICK="dc(1);document.forms[0].com.value='.$cmd_value.';document.forms[0].id_activate.value='.$domain['id'].';document.forms[0].submit();"/>';
								$res.= '</ENTITY-ITEM>';
							break;
			
							default :
								$res.= '<ENTITY-ITEM STYLE="padding-left:25px;" CAPTION="'.$this->get($key).'"/>';				
							break;
					
						}
					}				
					$res.= '</ENTITY>';
				}
			}			
			$res.= $this->BottomPanel();
			$res .= $this->addSaveButtons();
			$res.='</ENTITYLIST></PAGE>';			

		return $res;
		
	}
	
	function addPaging()
	{
		if($this->size > 0)	
		{
			$page_size = array(5, 10, 15);
			$res = '<PAGE-STRIP><PAGE-SIZE>'.lmsg('clist__page_size').'</PAGE-SIZE>';
			foreach ($page_size as $val)
			{
				if($this->page_size == $val) $res .= sprintf('<PAGE-S CURRENT="true" >%d</PAGE-S>', $val);
				else $res .= sprintf('<PAGE-S URL="%sto_page_size=%d&amp;to_page_list=%s" ONCLICK="dc();">%d</PAGE-S>', $this->getAction(), $val, get_class($this), $val);
			}
			$res .= sprintf('<BRS>%d-%d of %d total</BRS>', $this->page * $this->page_size + 1, min(($this->page + 1) * $this->page_size, $this->size), $this->size); 
			
			for($i = 0; $i < $this->size / $this->page_size; $i++)
			{
				if($i == $this->page) $res .= sprintf('<PAGE CURRENT="true">%s</PAGE>', $i + 1);
				else $res .= sprintf('<PAGE URL="%sto_page=%d&amp;to_page_list=%s" >%d</PAGE>', $this->getAction(), $i, get_class($this), $i + 1);
			}	
			$res .=	'<PREV-PAGE-SET /><PREV-PAGE /><NEXT-PAGE-SET /><NEXT-PAGE />';
			$res .= '<FIRST-PAGE CAPTION="First" />';
			$res .= sprintf('<LAST-PAGE CAPTION="last" URL="%sto_page=%d&amp;to_page_list=%s" />', $this->getAction(), floor($this->size / $this->page_size), get_class($this));
			$res .= '</PAGE-STRIP>';
			return $res;
		}
	}
	
	function BottomPanel()
	{
		$res .= '<BOTTOM-PANEL>';
		$res .= $this->addPaging();
		if($this->size > 0)	$res .= $this->addBottomButtons();
		$res .= $this->addTabs();
		$res .= '</BOTTOM-PANEL>';
		return $res;		
	}
	
	function addBottomButtons()
	{
		$res .= '<BUTTON NAME="bt_delete" CAPTION="'.lmsg('Delete').'" ONCLICK="var items; items = doActivate(true); if(items &amp;&amp; confirm(\' \' + items + \' - selected. Delete items?\')) {dc(1);document.forms[0].com.value=1003;document.forms[0].submit();}"/>';
		return $res;
	}
	
	function addTabs($PageList = null, $current = null)
	{
		if (!is_null($PageList)){
			if(is_null($current)) $current = $this->getTab();
			$str ="<TABS FORM=\"".$this->form."\">";
			$i=1;	
			foreach ($PageList as $key => $val)
				{
				$str.="<TAB";
				if ($key==$current)
					$str.=" ACTIVE=\"yes\"";
				$str.=" NAME=\"".$key."\"";
				if ($i==1) $str.=" CLASS=\"first\"";
				if ($i==count($PageList)) $str.=" CLASS=\"last\"";
				$str.=">".$val."</TAB>";
				$i++;
				}
			$str.="</TABS>";
			return $str;
		} else 
			return "";
	}
	
	function getTab()
	{
		return null;
	}
	
	function addSaveButtons()
	{
		return '';
	}
}

class ctlList extends ctlBaseList
{
	function ctlList($action = POST_HANDLER , $form = DEFAULT_FORM)
	{
		parent::ctlBaseList($action, $form);
	}
	
	function addBottomButtons()
	{
		$res .= '<BUTTON NAME="bt_activate" CAPTION="'.lmsg('RA__btn_activate').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1001;document.forms[0].submit();}"/>';
		$res .= '<BUTTON NAME="bt_deactivate" CAPTION="'.lmsg('RA__btn_deactivate').'" ONCLICK="if(doActivate(false)){dc(1);document.forms[0].com.value=1002;document.forms[0].submit();}"/>';
		$res .= parent::addBottomButtons();
		return $res;
	}
}

class ctlHostList extends ctlList
{
	function ctlHostList($action = '', $list = null)
	{
		parent::ctlList($action);

		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'RANGE' => array('caption' => lmsg('__Range')),
		'HOST_NAME' => array('caption' => lmsg('__Host_Name'), 'type' => 'link'),
	 	'IP_ADDRESS' => array('caption' => lmsg('__Ip_Address')),
	 	'OWNER' => array('caption' => lmsg('__Owner')),
	 	);
	 	
	 	if($_SESSION['user_role'] == 'root') $columns['RESELLERS'] = array('caption' => lmsg('__Resellers'));
	 	
		$this->filter_on = 'HOST_NAME';
		
		parent::setCaption($columns);
		
		parent::setData($list);
	}
	
	function id()
	{
		return $this->get('HOST_NAME');
	}

	function checkbox()
	{
		return '<CHECK NAME="sb_cc_obj_ids" VALUE="'.$this->get('HOST_NAME').'"'. ($this->is_disabled() ? ' DISABLED="true" ' : '') .'/>';
	}
	
	function is_disabled()
	{
		return parent::is_disabled() || ($this->get('OWNER') != $GLOBALS['server']['username']);
	}
	
	function addHeadButtons()
	{
		$btns = parent::addHeadButtons();
		$btns .= '<BUTTON NAME="add" CAPTION="'.lmsg('RA__btn_add_host').'" ONCLICK="dc(1);document.location.replace(\'?ra_cmd='.HOST.'&amp;id='.NEW_ID.'\');"/>';
		$btns .= '<BUTTON NAME="add_range" CAPTION="'.lmsg('RA__btn_add_host_range').'" ONCLICK="dc(1);document.location.replace(\'?ra_cmd='.RANGE.'&amp;id='.NEW_ID.'\');"/>';
		return  $btns;
	}

	function addBottomButtons()
	{
		$btns = parent::addBottomButtons();
		$btns .= '<BUTTON NAME="bt_retrieve" CAPTION="'.lmsg('Retrieve Hosts').'" ONCLICK="var items; items = doActivate(true); if(items > 0) { dc(1);document.forms[0].com.value=1012;document.forms[0].submit();}"/>';
		return  $btns;
	}
	
	function linkHOST_NAME()
	{
		if($this->get('RANGE') == '+') 
			return "/index.php?ra_cmd=".RANGE."&amp;id=".$this->id();
		else		
			return "/index.php?ra_cmd=".HOST."&amp;id=".$this->id();
	}
	
	function getRANGE()
	{
	    switch($this->_get('RANGE'))
	    {
		case '0' : 
		    return '-';
		break;
		
		case '1' :
		    return '+';
		break;
		
		default:
		    return $this->_get('RANGE');
	    }
	}
}

class ctlSkinList extends ctlList
{
	function ctlSkinList($action = '', $list = null)
	{
		parent::ctlList($action);

		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
		'ID' => array('caption' => lmsg('__ID')),
	 	'CAPTION' => array('caption' => lmsg('RA__Caption')),
	 	);
		
		parent::setCaption($columns);
		
		parent::setData($list);
	}
	
	function id()
	{
		return $this->get('ID');
	}
	
	function is_disabled()
	{
	    return parent::is_disabled() || $this->id() == 'default';
	}
}

class ctlLangList extends ctlBaseList
{
	function ctlLangList($action = '', $list = null)
	{
		parent::ctlBaseList($action);

		$columns = array(
	 	'ID' => array('caption' => lmsg('RA__ID')),
		'LANG' => array('caption' => lmsg('RA__Language')),
	 	'COUNTRY' => array('caption' => lmsg('RA__Country')),
	 	'CAPTION' => array('caption' => lmsg('RA__Caption'))
	 	);
		
		parent::setCaption($columns);
		
		parent::setData($list);
		
		$lng = new RA_Langs();
		$this->current = $lng->getCurrent();
	}

	function id()
	{
		return $this->get('ID');
	}

	function addBottomButtons()
	{
		$res .= '<BUTTON NAME="bt_delete" CAPTION="'.lmsg('Delete').'" ONCLICK="var items; items = doDelete(true); if(items &amp;&amp; confirm(\' \' + items + \' - selected. Delete items?\')) {dc(1);document.forms[0].com.value=1003;document.forms[0].submit();}"/>';
		return $res;
	}
	
	function is_disabled()
	{
	    return parent::is_disabled() || $this->current == $this->id();// $this->size == 1;
	}
}

class ctlTemplateList extends ctlList
{
	function ctlTemplateList($action = '', $list = null)
	{
		parent::ctlList($action);

		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'ID' => array('caption' => lmsg('__ID')),
	 	'CATEGORY' => array('caption' => lmsg('RA__Category'))
	 	);
		
		parent::setCaption($columns);
		
		parent::setData($list);
	}
	
	function id()
	{
		return $this->get('ID');
	}
	
	function addHeadButtons()
	{
		$btns = parent::addHeadButtons();
//		$btns .= '<BUTTON NAME="add" CAPTION="Add Host" ONCLICK="dc(1);document.location.replace(\'?ra_cmd='.HOST.'\');"/>';
		return  $btns;
	}
}

class ctlModuleList extends ctlList
{
	function ctlModuleList($action = '', $list = null)
	{
		parent::ctlList($action);

		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),		
	 	'NAME' => array('caption' => lmsg('RA_Name')),		
	 	'VERSION' => array('caption' => lmsg('RA_Version')),
	 	'TYPE' => array('caption' => lmsg('RA_Type')),
	 	'DESCRIPTION' => array('caption' => lmsg('RA_Description'))
	 	);
		
		parent::setCaption($columns);
		
		parent::setData($list);
	}
	
	function id()
	{
		return $this->get('NAME');
	}
	
	function addHeadButtons()
	{
		$btns = parent::addHeadButtons();
		return  $btns;
	}
}

class ctlPlanList extends ctlList
{
	function ctlPlanList($action = '', $list = null)
	{
		parent::ctlList($action);

		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'NAME' => array('caption' => lmsg('__Name'), 'type' => 'link'),
	 	'FOR_TRIAL_SITES' => array('caption' => lmsg('RA__for_trial_sites'), 'type' => 'link'),
	 	'DESCRIPTION' => array('caption' => lmsg('RA__Description')),
	 	'OWNER' => array('caption' => lmsg('__Owner'))
	 	);
		
		parent::setCaption($columns);
		
		parent::setData($list);
	}
	
	function id()
	{
		return $this->get('NAME');
	}

	function is_disabled()
	{
		return parent::is_disabled() || ($this->get('OWNER') != $GLOBALS['server']['username']);
	}
	
	function  checkbox_is_disabled()
	{
		return $this->get("BASE_PLAN") == "yes";
	}
	
	function addHeadButtons()
	{
		$btns = parent::addHeadButtons();
		$btns .= '<BUTTON NAME="add" CAPTION="'.lmsg('RA_Add_Plan').'" ONCLICK="dc(1);document.location.replace(\'?ra_cmd='.PLAN.'&amp;id='.NEW_ID.'\');"/>';
		return  $btns;
	}
	
	function linkNAME()
	{
		return "/index.php?ra_cmd=".PLAN."&amp;id=".urlencode($this->id());
	}
	
	function linkFOR_TRIAL_SITES()
	{
		if($this->get('OWNER') == $GLOBALS['server']['username'])
		{
			if($this->get('FOR_TRIAL_SITES') == 'yes')
			{
				$link = sprintf("javascript: var id=document.getElementById('id_activate'); if(confirm('%s')) { id.value = '%s'; dc(1);document.forms[0].com.value=1011; document.%s.submit()} else {loff();_refresh(this)}",
						lmsg('RA__confirm_trial_site_unset'), $this->get('NAME'), $this->form);
			}
			else 
			{
				$link = sprintf("javascript: var id=document.getElementById('id_activate'); if(confirm('%s')) { id.value = '%s'; dc(1);document.forms[0].com.value=1010; document.%s.submit()} else {loff();_refresh(this)}",
						lmsg('RA__confirm_trial_site_set'), $this->get('NAME'), $this->form);
			}
			return $link;
		}
	}
}

class ctlSiteList extends ctlList
{
	function ctlSiteList($action = '', $list = null)
	{
		parent::ctlList($action);
		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'SITE_ALIAS' => array('caption' => lmsg('RA__Site_Alias'), 'type' => 'link'),	 	
	 	'PUBLISH' => array('caption' => lmsg('RA__Publish')),
	 	'TYPE' => array('caption' => lmsg('RA__Type')),
	 	'RESELLER' => array('caption' => lmsg('RA__Reseller')),
	 	'CREATION_DATE' => array('caption' => lmsg('RA__Creation_Date')),
	 	'EXPIRATION_DATE' => array('caption' => lmsg('RA__Expiration_Date'))
	 	);
		
		parent::setCaption($columns);
		
		parent::setData($list);
	}
	
	function addBottomButtons()
	{
		$res .= parent::addBottomButtons();		
		$res .= '<BUTTON CAPTION="'.lmsg('Trial to Regular').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1004;document.forms[0].submit();}"/>';
		$res .= '<BUTTON CAPTION="'.lmsg('Deny publish').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1005;document.forms[0].submit();}"/>';
		$res .= '<BUTTON CAPTION="'.lmsg('Allow publish').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1006;document.forms[0].submit();}"/>';
		return $res;
	}
	
	function id()
	{
		return $this->get('SITE_ALIAS');
	}
	
	function addHeadButtons()
	{
		$btns = parent::addHeadButtons();
		$btns .= '<BUTTON NAME="addtrial" CAPTION="'.lmsg('RA_Add_Trial_site').'" ONCLICK="dc(1);document.location.replace(\'?ra_cmd='.SITE.'&amp;id='.NEW_ID.'&amp;type=TRIAL\');"/>';
		$btns .= '<BUTTON NAME="add" CAPTION="'.lmsg('RA_Add_Regular_site').'" ONCLICK="dc(1);document.location.replace(\'?ra_cmd='.SITE.'&amp;id='.NEW_ID.'&amp;type=REGULAR\');"/>';
		return  $btns;
	}
	
	function linkSITE_ALIAS()
	{
//		echo "/index.php?ra_cmd=".SITE."&id=".$this->id() . "<BR>";
		return "/index.php?ra_cmd=".SITE."&amp;id=".$this->id();
	}
	
	function getRESELLER()
	{
		if($_SESSION['user_role'] == 'root' && $this->_get('RESELLER') == $GLOBALS['server']['username']) return '-';
		else return $this->_get('RESELLER');
	}

	function getPUBLISH()
	{
	    switch($this->_get('PUBLISH'))
	    {
		case '0' : 
		    return '-';
		break;
		
		case '1' :
		    return '+';
		break;
		
		default:
		    return $this->_get('PUBLISH');
	    }
	}
	
}

?>