<?

class ctlResellerList extends ctlBaseList
{
	function ctlResellerList($action = '', $list = null)
	{
		parent::ctlBaseList($action);

		$columns = array(
	 	'LOGIN' => array('caption' => lmsg('RA_Login'), 'type' => 'link'),
	 	'DOMAIN' => array('caption' => lmsg('RA_Domain')),
		'SITES' => array('caption' => lmsg('RA_Sites')),
	 	);

		parent::setCaption($columns);
		$this->setFilterOn('LOGIN');
		parent::setData($list);
	}
	
	function id()
	{
		return $this->get('LOGIN');
	}
	
	function addHeadButtons()
	{
		$btns = parent::addHeadButtons();
		$btns .= '<BUTTON NAME="add" CAPTION="Add Reseller" ONCLICK="dc(1);document.location.replace(\'?ra_cmd='.RESELLER.'&amp;id='.NEW_ID.'\');"/>';
		return  $btns;
	}
	
	function linkLOGIN()
	{
		return "/index.php?ra_cmd=".RESELLER."&amp;id=".$this->id();
	}
}

//
class ctlResellerForm extends ctlForm 
{
	function ctlResellerForm($data)
	{
		$skins = get_skin_list();
		$langs = get_lang_list();

		$fields = array('DOMAIN' => array('type' => TEXT, 'caption' => lmsg('RA_Domain'), 'required' => 1), 
						'EMAIL' => array('type' => TEXT, 'caption' => lmsg('RA_Email'), 'required' => 1), 
						'NAME' => array('type' => TEXT, 'caption' => lmsg('RA_Name'), 'required' => 1), 
						'LOGIN' => array('type' => TEXT, 'caption' => lmsg('RA_Login'), 'required' => 1), 												
						'PSWD' => array('type' => PASSWORD, 'caption' => lmsg('RA_Password'), 'required' => 1),
						'PSWD_CONF' => array('type' => PASSWORD, 'caption' => lmsg('RA_Confirm password'), 'required' => 1),
						'LIMIT_SITES' => array('type' => TEXT, 'caption' => lmsg('RA_Regular_sites_limit')), 
						'LIMIT_HOSTS' => array('type' => TEXT, 'caption' => lmsg('RA_Hosts_limit')), 												
						'LANGUAGE' => array('type' => SELECT, 'caption' => lmsg('RA_Language'), 'list' => $langs),
						'SKIN' => array('type' => SELECT, 'caption' => lmsg('RA_Skin'), 'list' => $skins),
						);
		if(isset($_GET['id']) && $_GET['id'] != NEW_ID)
		{
			$data['PSWD'] = PASSWD_NULL;
			$data['PSWD_CONF'] = PASSWD_NULL;
		}
		if ($data['LIMIT_HOSTS'] == "-1"){
			$data['LIMIT_HOSTS'] = "";
		}
		if ($data['LIMIT_SITES'] == "-1"){
			$data['LIMIT_SITES'] = "";
		}

		parent::ctlForm($data, $fields);
	}
}

class ctlResellerFormList extends ctlList
{
	function ctlResellerFormList($columns = null, $api_class = null, $in_list_data = null)
	{
		parent::ctlList(POST_HANDLER);

		$this->setCaption($columns);

		$list = new $api_class();
		$this->no_links = true;
		$list->getList();

		$this->in_list_data = $in_list_data;

		$data_list = array_filter($list->list, array($this,'filter_by'));
		parent::setData($data_list);
	}
	
	function setCaption($caption)
	{
		$first = array(
			'inlist' => array('caption' => lmsg('RA_In_list'), 'type' => 'handler', 'handler' => 'inlist')
		);
		parent::setCaption(array_merge((array)$first, (array)$caption));
	}
	
	function inlist()
	{
		if(array_key_exists($this->id(), (array)$this->in_list_data())) return '+'; else return '-';
	}

	function addBottomButtons()
	{
		$res .= '<BUTTON CAPTION="'.lmsg('RA_Add_to_list').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1009;document.forms[0].submit();}"/>';
		$res .= '<BUTTON CAPTION="'.lmsg('RA_Remove_from_list').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1008;document.forms[0].submit();}"/>';
		return $res;
	}
	
	function addTabs($tabs = null, $current = null)
	{
		return "";
	}
	
	function getTab()
	{
		return $_GET[TAB];
	}
	
	function addSaveButtons()
	{
		$res = 	'<HIDDEN ID="do" NAME="todo"/>';
		$res.='<BUTTON ID="bid-ok" name="bname_ok" CAPTION="'.lmsg('RA__btn_save').'" ONCLICK="document.'.$this->form.'.todo.value = \''.SAVE.'\'; document.'.$this->form.'.submit();"/>';		
		$res.='<BUTTON ID="bid-cancel" name="bname_cancel" CAPTION="'.lmsg('RA__btn_cancel').'" ONCLICK="document.'.$this->form.'.todo.value = \''.CANCEL.'\'; document.'.$this->form.'.submit();"/>';
		return parent::addSaveButtons() . $res;
	}

}

class ctlResellerFormHosts extends ctlResellerFormList
{
	function ctlResellerFormHosts($in_list_data)
	{
		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'RANGE' => array('caption' => lmsg('__Range')),
		'HOST_NAME' => array('caption' => lmsg('__Host_Name'), 'type' => 'link'),
	 	'IP_ADDRESS' => array('caption' => lmsg('__Ip_Address')),
	 	'OWNER' => array('caption' => lmsg('__Owner')),
	 	);

		$this->filter_on = 'HOST_NAME';
		parent::ctlResellerFormList($columns, 'RA_Hosts', $in_list_data);
	}
	
	function filter_by($a)
	{
		return $a['OWNER'] == $GLOBALS['server']['username'] || $a['OWNER'] == $this->in_list_data['LOGIN'];
	}
	
	function id()
	{
		return $this->get('HOST_NAME');
	}
	
	function getRANGE()
	{
	    switch($this->_get('RANGE'))
	    {
		case '0' : 
		    return '-';
		break;
		
		case '1' :
		    return '+';
		break;
		
		default:
		    return $this->_get('RANGE');
	    }
	}
	
	function in_list_data()
	{
		return $this->in_list_data['HOSTS'];
	}
	
	function is_disabled()
	{
		// Bug 62789 temporary workaround
		return parent::is_disabled() || $this->get('OWNER') != $GLOBALS['server']['username'];
	}
}

class ctlResellerFormSites extends ctlList
{
	function ctlResellerFormSites($in_list_data)
	{
		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'PUBLISH' => array('caption' => lmsg('RA__Publish')),
	 	'TYPE' => array('caption' => lmsg('RA__Type')),
	 	'SITE_ALIAS' => array('caption' => lmsg('RA__Site_Alias'), 'type' => 'link'),	 		 	
	 	'CREATION_DATE' => array('caption' => lmsg('RA__Creation_Date')),
	 	'EXPIRATION_DATE' => array('caption' => lmsg('RA__Expiration_Date'))
	 	);

		parent::ctlList(POST_HANDLER);

		$this->setCaption($columns);

		parent::setData($in_list_data['SITES']);
	}
	
	function setCaption($caption)
	{
		parent::setCaption($caption);
		unset($this->fields['checkbox']);
	}
	
	function addSaveButtons()
	{
		$res = 	'<HIDDEN ID="do" NAME="todo"/>';
		$res.='<BUTTON ID="bid-ok" name="bname_ok" CAPTION="'.lmsg('RA__btn_save').'" ONCLICK="document.'.$this->form.'.todo.value = \''.SAVE.'\'; document.'.$this->form.'.submit();"/>';		
		$res.='<BUTTON ID="bid-cancel" name="bname_cancel" CAPTION="'.lmsg('RA__btn_cancel').'" ONCLICK="document.'.$this->form.'.todo.value = \''.CANCEL.'\'; document.'.$this->form.'.submit();"/>';
		return parent::addSaveButtons() . $res;
	}
	
	function addBottomButtons()
	{
		return "";
	}	

	function id()
	{
		return $this->get('SITE_ALIAS');
	}

	function getPUBLISH()
	{
	    switch($this->_get('PUBLISH'))
	    {
		case '0' : 
		    return '-';
		break;
		
		case '1' :
		    return '+';
		break;
		
		default:
		    return $this->_get('PUBLISH');
	    }
	}
	
}

class ctlResellerFormPlans extends ctlList
{
	function ctlResellerFormPlans($in_list_data)
	{
		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'NAME' => array('caption' => lmsg('__Name'), 'type' => 'link'),
	 	'FOR_TRIAL_SITES' => array('caption' => lmsg('RA__for_trial_sites')),
	 	'DESCRIPTION' => array('caption' => lmsg('RA__Description')),
	 	'OWNER' => array('caption' => lmsg('__Owner'))
	 	);
		parent::ctlList(POST_HANDLER);

		$this->setCaption($columns);

		parent::setData($in_list_data['PLANS']);
	}
	
	function setCaption($caption)
	{
		parent::setCaption($caption);
		unset($this->fields['checkbox']);
	}
	
	function addSaveButtons()
	{
		$res = 	'<HIDDEN ID="do" NAME="todo"/>';
		$res.='<BUTTON ID="bid-ok" name="bname_ok" CAPTION="'.lmsg('RA__btn_save').'" ONCLICK="document.'.$this->form.'.todo.value = \''.SAVE.'\'; document.'.$this->form.'.submit();"/>';		
		$res.='<BUTTON ID="bid-cancel" name="bname_cancel" CAPTION="'.lmsg('RA__btn_cancel').'" ONCLICK="document.'.$this->form.'.todo.value = \''.CANCEL.'\'; document.'.$this->form.'.submit();"/>';
		return parent::addSaveButtons() . $res;
	}
	
	function addBottomButtons()
	{
		return "";
	}	
}

?>