<?

//
class ctlSiteForm extends ctlReadonlyForm 
{
	function ctlSiteForm($data)
	{
		if($_GET['type'] == 'TRIAL') $data['TYPE'] = 'TRIAL';
		$this->is_trial = strcasecmp($data['TYPE'], 'TRIAL') === 0;

		$plans = get_plan_list($this->is_trial && $_GET['type'] == 'TRIAL');
//		$plans = get_plan_list($this->is_trial);
//		$resellers = get_reseller_list();
		if($_SESSION['user_role'] == 'root'){
//			if (isset($resellers)){
//				$resellers = array_merge(array($GLOBALS['server']['username'] => 'none'), (array)$resellers);
//				$resellers_disabled = false;
//			} else {
				$resellers = array($GLOBALS['server']['username'] => 'none');
				$resellers_disabled = true;
//			}
		}
		
		if($this->is_trial && !isset($data['PLAN'])) 
		{
			$plns = array_keys($plans);
			$data['PLAN'] = $plns[0];
		}
		
		$langs = get_lang_list();
		
		$fields = array('SITE_ALIAS' => array('type' => TEXT, 'caption' => lmsg('RA_Site_Alias'), 'required' => 0), 
						'ACTIVE' => array('type' => CHECKBOX, 'caption' => lmsg('RA_Active')),
						'PLAN' => array('type' => SELECT, 'caption' => lmsg('RA_Plan'), 'list' => $plans, 'disabled' => $this->is_trial, 'required' => 1),
						'LANGUAGE' => array('type' => SELECT, 'caption' => lmsg('RA_Language'), 'list' => $langs, 'required' => 0)
						);
		if($_SESSION['user_role'] == 'root')
		{
			$fields = array_merge($fields, array('RESELLER' => array('type' => SELECT, 'caption' => lmsg('RA_Reseller'), 'list' => $resellers, 'disabled' => $resellers_disabled)));
		}

		$fields = array_merge($fields, array(	
						'PSWD' => array('type' => PASSWORD, 'caption' => lmsg('RA_Password')),
						'PSWD_CONF' => array('type' => PASSWORD, 'caption' => lmsg('RA_Confirm password')),
						));

		if(isset($_GET['id']) && $_GET['id'] != NEW_ID && $data['PASSWORD_PROTECTED'] != "no")
		{
			$data['PSWD'] = PASSWD_NULL;
			$data['PSWD_CONF'] = PASSWD_NULL;
		}

		$this->readonly = $data['RESELLER'] != $GLOBALS['server']['username'] && $_GET['id'] != NEW_ID;
				
		parent::ctlReadonlyForm($data, $fields);
	}
}

class ctlPublishForm extends ctlReadonlyForm 
{
	function ctlPublishForm($data)
	{
		$fields = array('PUBLISH' => array('type' => CHECKBOX, 'caption' => lmsg('RA_Allow_publishing_sites')),
						'SITE_HOST_NAME' => array('type' => TEXT, 'caption' => lmsg('RA_Site_Host_Name')),
						'MODE' => array('type' => SELECT, 'caption' => lmsg('RA_Mode'), 'list' => array('ftp' => lmsg('RA_ftp'), 'vps' => lmsg('RA_vps')), 'onchange' => "document.".$this->name.".submit();", 'required' => 1)
						);
		if(!isset($data['MODE'])) $data['MODE'] = 'ftp';
		if($data['MODE'] == 'ftp')
		{
			$hosts = $this->get_host_list($data);
			$fields = array_merge((array)$fields, 
				array(	'FTP_HOST' => array('type' => SELECT, 'caption' => lmsg('RA_FTP_Host'), 'list' => $hosts, 'required' => 1),
						'FTP_LOGIN' => array('type' => TEXT,  'caption' => lmsg('RA_FTP_Login'), 'required' => 1),
						'FTP_PASSWORD' => array('type' => PASSWORD, 'caption' => lmsg('RA_FTP_Password'), 'required' => 1),
						'FTP_WORK_DIRECTORY' => array('type' => TEXT, 'caption' => lmsg('RA_FTP_Work_Directory'), 'required' => 1),
					  )
			);
			
//			if(isset($_GET['id']) && $_GET['id'] != NEW_ID)
//			{
//				$data['FTP_PASS'] = PASSWD_NULL;
//			}
		}
		elseif($data['MODE'] == 'vps')
		{
			$hosts = $this->get_host_list($data);
			$fields = array_merge((array)$fields, 
				array(	'DOMAIN' => array('type' => TEXT, 'caption' => lmsg('RA_VPS_Domain'), 'required' => 1),
						'SERVICE_VE_IP' => array('type' => TEXT,  'caption' => lmsg('RA_VPS_Service_VE_IP_Address'), 'required' => 1),
						'VPS_ID' => array('type' => TEXT, 'caption' => lmsg('RA_VPS_Identifier'), 'required' => 1),
						'VPS_WORKDIR' => array('type' => TEXT, 'caption' => lmsg('RA_VPS_Work_Directory'), 'required' => 1),
						'VPS_USER' => array('type' => TEXT, 'caption' => lmsg('RA_VPS_Owner_User'), 'required' => 1),
						'VPS_GROUP' => array('type' => TEXT, 'caption' => lmsg('RA_VPS_Owner_Group'), 'required' => 1)
					  )
			);
		}

		$this->readonly = $data['RESELLER'] != $GLOBALS['server']['username'] && $_GET['id'] != NEW_ID;
				
		parent::ctlReadonlyForm($data, $fields);
	}

function get_host_list($data)
{
	if(is_array($data['SITE_PLAN']['HOSTS']))
	{
		foreach ($data['SITE_PLAN']['HOSTS'] as $item)
		{
			$res[$item['HOST_NAME']] = $item['HOST_NAME'];
		}
		return $res;
	}
}
	
}

class ctlEmailForm extends ctlReadonlyForm 
{
	function ctlEmailForm($data)
	{
		$fields = array('SEND_MAIL' => array('type' => CHECKBOX, 'caption' => lmsg('RA_Send_site_information_to_email')),
						'EMAIL' => array('type' => TEXT, 'caption' => lmsg('RA_Email')),
						);
						
		$this->readonly = $data['RESELLER'] != $GLOBALS['server']['username'] && $_GET['id'] != NEW_ID;
								
		parent::ctlReadonlyForm($data, $fields);
	}
}

class ctlPlanForm extends ctlReadonlyForm
{
	function ctlPlanForm($data)
	{
		$fields = array(
			'PLAN' => array('caption' => lmsg('RA_Name'), 'type' => LABEL),
			'LAST_REVISION_DATE' => array('caption' => lmsg('RA_Last_revision_date'), 'type' => LABEL),
			'PAGES_NUMBER' => array('caption' => lmsg('RA_Pages_number'), 'type' => TEXT, 'required' => 1)
		);
		
		$this->readonly = $data['RESELLER'] != $GLOBALS['server']['username'] && $_GET['id'] != NEW_ID;

		parent::ctlReadonlyForm($data['SITE_PLAN'], $fields);
	}
	
	function addTabs($tabs = null, $current = null)
	{
		$tabs = array(GENERAL => lmsg('RA_General'), HOSTS => lmsg('RA_Hosts'), MODULES => lmsg('RA_Modules'), TEMPLATES => lmsg('RA_Templates'));
		return parent::addTabs($tabs);
	}
	
	function getTab()
	{
		return $_GET[TAB];		
	}
}

class ctlOwnPlanForm extends ctlForm
{
	function ctlOwnPlanForm($data)
	{
		$fields = array(
			'NAME' => array('caption' => lmsg('RA_Name'), 'type' => TEXT,'required' => 1),
			'ACTIVE' => array('caption' => lmsg('RA_Active'), 'type' => CHECKBOX, 'disabled' => ($data['BASE_PLAN'] == 'yes' || $data['FOR_TRIAL_SITES'] == 'yes')),
			'DESCRIPTION' => array('caption' => lmsg('RA_Description'), 'type' => TEXT),
			'PAGES_NUMBER' => array('caption' => lmsg('RA_Pages_number'), 'type' => TEXT,'required' => 1),
			'sb_apply_to_all' => array('caption' => lmsg('RA_Apply_changes_to_all_inherited_plans'), 'type' => CHECKBOX)
		);
		
		parent::ctlForm($data, $fields);
	}
}

class ctlPlanFormList extends ctlList
{
	function ctlPlanFormList($columns = null, $api_class = null, $plan = null)
	{
		parent::ctlList(POST_HANDLER);

		$this->setCaption($columns);

		$list = new $api_class();
		$this->no_links = true;
		$list->getList();
		
		$data_list = array_filter($list->list, array($this,'filter_by'));
		parent::setData($data_list);
		
		$this->plan = $plan;
	}
	
	function filter_by($a)
	{
		return $a['ACTIVE'] == 1;
	}
	
	function setCaption($caption)
	{
		$first = array(
			'inplan' => array('caption' => lmsg('RA_In_plan'), 'type' => 'handler', 'handler' => 'inplan')
		);
		parent::setCaption(array_merge((array)$first, (array)$caption));
	}
	
	function checkbox()
	{
		//if(!is_null($this->get('OWNER')) && $this->get('OWNER') != $GLOBALS['server']['username']) { return '<CHECK NAME="sb_cc_obj_ids" DISABLED="true" VALUE="'.$this->id().'"/>'; }
		//else return parent::checkbox();
		return parent::checkbox();
	}
	
	function inplan()
	{
		if(is_array($this->plan()) && array_key_exists($this->id(), $this->plan())) return '+'; else return '-';
	}
	
	function is_disabled()
	{
		$plan = $this->plan();
		return parent::is_disabled() || $this->readonly || $plan[$this->id()]['BASE_PART'] == 'yes';
	}

	function addBottomButtons()
	{
		if(!$this->readonly)
		{
			$res .= '<BUTTON CAPTION="'.lmsg('RA_Add_to_Site_Plan').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1009;document.forms[0].submit();}"/>';
			$res .= '<BUTTON CAPTION="'.lmsg('RA_Remove_from_Site_Plan').'" ONCLICK="if(doActivate(true)){dc(1);document.forms[0].com.value=1008;document.forms[0].submit();}"/>';
		}
		return $res;
	}
	
	function addTabs($tabs = null, $current = null)
	{
		$tabs = array(GENERAL => lmsg('RA_General'), HOSTS => lmsg('RA_Hosts'), MODULES => lmsg('RA_Modules'), TEMPLATES => lmsg('RA_Templates'));
		return parent::addTabs($tabs);
	}
	
	function getTab()
	{
		return $_GET[SUBTAB];
	}
	
	function addSaveButtons()
	{
		$res = 	'<HIDDEN ID="do" NAME="todo"/>';
		if(!$this->readonly)
		{
			$res.='<BUTTON ID="bid-ok" name="bname_ok" CAPTION="'.lmsg('RA__btn_save').'" ONCLICK="document.'.$this->form.'.todo.value = \''.SAVE.'\'; document.'.$this->form.'.submit();"/>';		
			$res.='<BUTTON ID="bid-cancel" name="bname_cancel" CAPTION="'.lmsg('RA__btn_cancel').'" ONCLICK="document.'.$this->form.'.todo.value = \''.CANCEL.'\'; document.'.$this->form.'.submit();"/>';
		}
		else 
			$res.='<BUTTON ID="bid-ok" name="bname_cancel" CAPTION="'.lmsg('RA__btn_ok').'" ONCLICK="document.'.$this->form.'.todo.value = \''.CANCEL.'\'; document.'.$this->form.'.submit();"/>';
			
		return parent::addSaveButtons() . $res;
	}

}

class ctlPlanFormHosts extends ctlPlanFormList
{
	function ctlPlanFormHosts($plan)
	{
		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'RANGE' => array('caption' => lmsg('__Range')),
		'HOST_NAME' => array('caption' => lmsg('__Host_Name')),
	 	'IP_ADDRESS' => array('caption' => lmsg('__Ip_Address')),
	 	'OWNER' => array('caption' => lmsg('__Owner')),
	 	'RESELLERS' => array('caption' => lmsg('__Resellers'))
	 	);
		$this->filter_on = 'HOST_NAME';
		
		$this->readonly = $plan['RESELLER'] != $GLOBALS['server']['username'] && $_GET['id'] != NEW_ID;
				
		parent::ctlPlanFormList($columns, 'RA_Hosts', $plan['SITE_PLAN']);
	}
	
	function id()
	{
		return $this->get('HOST_NAME');
	}
	
	function plan()
	{
		return $this->plan['HOSTS'];
	}
	
	function getRANGE()
	{
		return $this->_get('RANGE') == 1 ? '+' : '-';
	}
}

class ctlPlanFormModules extends ctlPlanFormList
{
	function ctlPlanFormModules($plan)
	{
		$columns = array(
	 	'NAME' => array('caption' => lmsg('RA_Name')),		
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'VERSION' => array('caption' => lmsg('RA_Version')),
	 	'TYPE' => array('caption' => lmsg('RA_Type')),
	 	'DESCRIPTION' => array('caption' => lmsg('RA_Description'))
	 	);

		$this->readonly = $plan['RESELLER'] != $GLOBALS['server']['username'] && $_GET['id'] != NEW_ID;
		parent::ctlPlanFormList($columns, 'RA_Modules', $plan['SITE_PLAN']);
	}

	function id()
	{
		return $this->get('NAME');
	}
	
	function plan()
	{
		return $this->plan['MODULES'];
	}
}

class ctlPlanFormTemplates extends ctlPlanFormList
{
	function ctlPlanFormTemplates($plan)
	{
		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'ID' => array('caption' => lmsg('__ID')),
	 	'CATEGORY' => array('caption' => lmsg('RA__Category'))
	 	);

		$this->readonly = $plan['RESELLER'] != $GLOBALS['server']['username'] && $_GET['id'] != NEW_ID;	
		parent::ctlPlanFormList($columns, 'RA_Templates', $plan['SITE_PLAN']);
	}
	
	function id()
	{
		return $this->get('ID');
	}
	
	function plan()
	{
		return $this->plan['TEMPLATES'];
	}
}

/* ----------------------------------------- */
//                own forms
/* ----------------------------------------- */
class ctlOwnPlanFormList extends ctlPlanFormList
{
	function ctlOwnPlanFormList($columns = null, $api_class = null, $plan = null)
	{
		parent::ctlPlanFormList($columns, $api_class, $plan);
	}
	
	function addTabs($tabs = null, $current = null)
	{
		return "";
	}
}

class ctlOwnPlanFormHosts extends ctlOwnPlanFormList
{
	function ctlOwnPlanFormHosts($plan)
	{
		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'RANGE' => array('caption' => lmsg('__Range')),
		'HOST_NAME' => array('caption' => lmsg('__Host_Name')),
	 	'IP_ADDRESS' => array('caption' => lmsg('__Ip_Address')),
	 	'OWNER' => array('caption' => lmsg('__Owner')),
	 	'RESELLERS' => array('caption' => lmsg('__Resellers'))
	 	);
		$this->filter_on = 'HOST_NAME';
		
		parent::ctlOwnPlanFormList($columns, 'RA_Hosts', $plan);
	}
	
	function id()
	{
		return $this->get('HOST_NAME');
	}
	
	function plan()
	{
		return $this->plan['HOSTS'];
	}
	
	function getRANGE()
	{
		return $this->_get('RANGE') == 1 ? '+' : '-';
	}
}

class ctlOwnPlanFormModules extends ctlOwnPlanFormList
{
	function ctlOwnPlanFormModules($plan)
	{
		$columns = array(
	 	'NAME' => array('caption' => lmsg('RA_Name')),		
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'VERSION' => array('caption' => lmsg('RA_Version')),
	 	'TYPE' => array('caption' => lmsg('RA_Type')),
	 	'DESCRIPTION' => array('caption' => lmsg('RA_Description'))
	 	);
		
		parent::ctlOwnPlanFormList($columns, 'RA_Modules', $plan);
	}

	function id()
	{
		return $this->get('NAME');
	}
	
	function plan()
	{
		return $this->plan['MODULES'];
	}
}

class ctlOwnPlanFormTemplates extends ctlOwnPlanFormList
{
	function ctlOwnPlanFormTemplates($plan)
	{
		$columns = array(
	 	'ACTIVE' => array('caption' => lmsg('__Status')),
	 	'ID' => array('caption' => lmsg('__ID')),
	 	'CATEGORY' => array('caption' => lmsg('RA__Category'))
	 	);
		
		parent::ctlOwnPlanFormList($columns, 'RA_Templates', $plan);
	}
	
	function id()
	{
		return $this->get('ID');
	}
	
	function plan()
	{
		return $this->plan['TEMPLATES'];
	}
}
?>