<?php
require_once(PRODUCT_ROOT_D.'/admin/htdocs/modules/sbm2/curl_send.php');
function parse_responce($node, $keys = null, $groups = null)
{
	//if(is_subclass_of($node, 'DomNode'))
	//{
		$res = array();

		$attributes = array();
		if($node->has_attributes())
		{
			foreach ($node->attributes() as $attribute)
			{
				$res[$attribute->name()] = htmlspecialchars($attribute->value());
			}
		}
		
		if($node->has_child_nodes ())
		{
			foreach($node->child_nodes() as $element)
			{
				$dom = parse_responce($element, $keys, $groups);
				if(is_array($groups) && isset($groups[$element->tagname()])) 
				{
					if(isset($keys[$element->tagname()]))
						$res[$groups[$element->tagname()]][$dom[$keys[$element->tagname()]]] = $dom;
					else 
						$res[$groups[$element->tagname()]][] = $dom;
				}
				else 
				{
					$res[isset($keys[$element->tagname()]) ? $dom[$keys[$element->tagname()]] : $element->tagname()] = $dom;
				}
			}
		}
		
		return $res;
	//}
}

class RA_Responce 
{
	var $script;
	var $dom;
	var $result;
	var $error = false;
	
	function RA_Responce($script = NULL)
	{
		$this->script = $script;
	}
	
	function send_command($cmd, $parameters = NULL, $script = "")
	{
		$this->error = false;
		$this->result = "";
		$par = "";

		if(is_array($parameters))
		{
			foreach ($parameters as $name => $param)
			{
				$par .= "&" . $name . "=" . urlencode(html_entity_decode($param));
//				$par .= "&" . $name . "=" . html_entity_decode($param);
			}
		}
		$this->last_cmd = $this->script."?cmd=".$cmd.$par;

		$resp = R_CURL_Send($this->script,"cmd=".$cmd.$par);
		logsbm2(sprintf("%s\n%s",$this->last_cmd, $resp));
		
        if($resp == '') { $this->set_error(array('MESSAGE' => '')); return false; }
	 	if(substr($resp, 0, 15) != '<RESULT_ACTION>') { $this->set_error(array('MESSAGE' => lmsg(' Incorrect responce from sitebuilder'))); return false;}

		$this->dom = @domxml_open_mem($resp);
		if (!$this->dom) {
 			$this->set_error(lmsg('RA__msg_err_parsing'));
 			$_SESSION['ra_cmd'] = MAIN;
 			$_SESSION['ch_ip'] = true;
 			return false;
 		}
		
 		$RESULT_ACTION = $this->dom->document_element();

 		if(!method_exists($RESULT_ACTION, 'has_child_nodes'))
 		{
 			//$this->set_error(array('MESSAGE' => ''));
 		}
 		elseif($RESULT_ACTION->has_child_nodes())
 		{
 			foreach($RESULT_ACTION->child_nodes() as $node)
 			{

 				switch ($node->tagname())
 				{
 					case 'RESULT' :
 						$this->result = $node;
 					break;
 					
 					case 'STATUS' :
 						$this->set_error($this->parse_error($node));
 					break;
 					
 				}
 				//$this->{$node->tagname()} = $node->get_content();
 			}
 		}

/*		else 
		go_to("/modules/".MODULE_NAME."/index.php?ra_cmd=main");
*/		
//		$nodes = $RESULT_ACTION->get_elements_by_tagname('STATUS');
// 		print_r($nodes[0]->get_content());
	}
	
	function parse_error($node)
	{
		if($node->has_attributes())
		{
			foreach ($node->attributes() as $attribute)
			{
				$res[$attribute->name()] = $attribute->value();
			}
		}
		$res['MESSAGE'] = $node->get_content();
		return $res;
	}
	
	function error()
	{
		return $this->error;
	}
	
	function set_error($error)
	{
		global $ERR_OK;
		if(in_array($error['CODE'], (array) $ERR_OK) || !$error) $this->error = false;
		else 
		{
			$this->error = $error;
			set_status(array('CODE' => $error['CODE'], 'MESSAGE' => $error['MESSAGE'], 'COMMAND' => $this->last_cmd));
		}
	}

	function set_status($error)
	{
		$this->error = false;
		set_status(array('MESSAGE' => $error['MESSAGE']));
	}
	
	function isError()
	{
		if($this->error) return true;
		else return false;
	}
	
	function serialize()
	{
		$_SESSION[lowcase_get_class($this)] = serialize($this);
	}
}


/*
api methods:
	getlist
	----------
	delete
*/

class RA_BaseList extends RA_Responce 
{
	var $script;	
	
	function RA_BaseList($script)
	{
		parent::RA_Responce($script);
	}

	function getList($cmd_getlist)
	{
		
		parent::send_command($cmd_getlist);
		$this->domlist = $this->result;
		
		$this->parseList();
	}
	
	function parseList()
	{
		//if(is_subclass_of($this->domlist, 'DomNode'))
		//{
			$this->list = array();
			
			if(method_exists($this->domlist, 'has_child_nodes') && $this->domlist->has_child_nodes())
			{
				foreach($this->domlist->child_nodes() as $element)
				{
					$attributes = array();
					if($element->has_attributes())
					{
						foreach ($element->attributes() as $attribute)
						{
							$attributes[$attribute->name()] = safetyhtml($attribute->value());
						}
					}
					$this->list[$this->id($attributes)] = $attributes;
					//$this->list[sizeof($this->list)] = $attributes;
				}
			}
		//}
		
	}
	
	function id($attributes)
	{
		return sizeof($this->list) + 1;
	}

	function xmlList($action = POST_HANDLER)
	{
		$name = substr(get_class($this),3, strlen(get_class($this)) - 4);
		$name = 'ctl' . $name . "List";
		
		$ctl = new $name($action);
		$ctl->setData($this->list);
		return $ctl->toxml();
	}
	
	function getPost($post = null)
	{
		if(is_null($post)) return $_POST;
		else return $post;
	}

	function process($post = null)
	{
		$post = $this->getPost($post);
		
		if($post['id_activate']) 
		{
			$ids = substr($post['id_activate'], 0, -1);
			switch ($post['com'])
			{
				case 1001 :
					$this->activate($ids);
				break;
	
				case 1002 :
					$this->deactivate($ids);
				break;
				
				case 1003 :
					$this->delete($ids);
				break;
				
			}
		}
	}

// ------------------------------------------------
// ---------------- API methods	-------------------
// ------------------------------------------------
	function delete($par, $ids, $cmd = 'delete')
	{
		$this->send_command($cmd, array($par => $ids));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}
}


/*
api methods:
	getlist
	----------
	delete
	----------
	setCurrent
	get_current
*/
class RA_List extends RA_AdvList 
{
	function RA_List($script)
	{
		RA_AdvList::RA_AdvList($script);
	}

	function getList($cmd_getlist)
	{
		parent::getList($cmd_getlist);
		
		$this->getCurrent();
	}
	
	function _getCurrent($cmd_getcurrent, $id_param)
	{
		$this->current = null;
		parent::send_command($cmd_getcurrent);
		$result = $this->result->child_nodes();
		if(!$this->error()) $this->current = $result[0]->get_attribute($id_param);
		return $this->current;
	}
	
	function current()
	{
		return $this->current;
	}
	
	function setCurrent($cmd, $key, $id)
	{
		parent::send_command($cmd, array($key => $id));
		if(!$this->error()) 
		{
			return true;
		}
	}
	
	function ctlSelect($name, $title)
	{
		if(is_array($this->list))
		{
			$xml = '<FIELD NAME="'.$name.'" TITLE="'.$title.'" TYPE="list">';
			foreach ($this->list as $item)
			{
				if($item['ACTIVE'] == 1 || !isset($item['ACTIVE'])) {
				$xml .= '<ITEM VALUE="'.$item['ID'].'"';
					if ($item['ID'] == $this->current()){
						$xml .= ' SELECTED="1"';
					}
					$xml .= '>'.$item['CAPTION'].'</ITEM>';
				}
			}
			$xml .= '</FIELD>';
		}
		return($xml);
	}
}

/*
api methods:
	getlist
	----------
	delete
	----------	
	activate
	deactivate

*/
class RA_AdvList extends RA_BaseList 
{
	function RA_AdvList($script)
	{
		RA_BaseList::RA_BaseList($script);
	}
	
	function activate($par, $ids, $cmd = 'activate')
	{
		$this->send_command($cmd, array($par => $ids));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}
	
	function deactivate($par, $ids, $cmd = 'deactivate')
	{
		$this->send_command($cmd, array($par => $ids));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}
	
	function xmlform($data = null, $class = null)
	{
		if(is_null($class))
		{
			$class = "ctl" . substr(get_class($this),3, strlen(get_class($this)) - 4) . "Form";
		}
		
		$form =	new $class($data);
		return $form->toxml(); 
	}
}

/*
api methods:
	getlist
	----------
	delete
	----------	
	activate
	deactivate
	----------
	add
*/
class RA_SuperAdvList extends RA_AdvList
{
	function RA_SuperAdvList($script)
	{
		parent::RA_AdvList($script);
	}
	
	function add($cmd, $post)
	{
		foreach ($post as $key => $val) $pars[$key] = $val;
		
		$this->send_command($cmd, $pars);
		if($this->error()) 
		{
			return false;
		}

		return true;
	}
	
	function process($post = null)
	{
		$post = $this->getPost($post);
		if($post['do'] == DO_ADD)
		{
			return $this->add($post);
		}
		else 
		{
			return parent::process($post);
		}
	}
}

class RA_Hosts extends RA_SuperAdvList 
{
	function RA_Hosts()
	{
		parent::RA_AdvList("ipmanager.php");
	}
	
	function getList()
	{
		parent::getList("get_hosts");
	}
	
	function activate($ids)
	{
		return parent::activate("sbra_hosts", $ids);
	}

	function deactivate($ids)
	{
		return parent::deactivate("sbra_hosts", $ids);
	}
	
	function delete($ids)
	{
		return parent::delete("sbra_hosts", $ids);
	}

	function retrieve($ids)
	{
		$this->send_command('retrieve', array('sbra_hosts' => $ids));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}

	function assign_resseller($id, $resellers)
	{
		$this->send_command('assign_resellers', array('sbra_hosts' => $id, 'sb_resellers' => $resellers));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}
	
	function deassign_resseller($id, $resellers)
	{
		$this->send_command('deassign_resellers', array('sbra_hosts' => $id, 'sb_resellers' => $resellers));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}

	function process($post = null)
	{
		$post = $this->getPost($post);
		if($post['id_activate']) 
		{
			$ids = substr($post['id_activate'], 0, -1);
			switch ($post['com'])
			{
				case 1012 :
					$this->retrieve($ids);
				break;

				default:
					parent::process($post);
			}
		}
	}
	
	function id($attributes)
	{
		return $attributes['HOST_NAME'] . ',' . $attributes['OWNER'];
	}
	
	function get_details($id)
	{
		return $this->send_command("get_host_details", array('sbra_hosts' => $id));
	}

	function parse_details()
	{
		$data = parse_responce($this->result, array('RESELLER' => 'LOGIN'), array('RESELLER' => 'RESELLER_LIST'));

		// for range
		if($data['HOST']['RANGE'] == 1)
		{
			if (ereg ("([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})-([0-9]{1,3})", $data['HOST']['HOST_NAME'], $regs)) {
				$data['HOST']['sb_ftp_host_fst'] = $regs[1].'.'.$regs[2].'.'.$regs[3].'.'.$regs[4];
				$data['HOST']['sb_ftp_host_sec'] = $regs[1].'.'.$regs[2].'.'.$regs[3].'.'.$regs[5];
			} else {
			   
			}
		}
		
		$data['HOST']['RESELLERS_OLD'] = $data['HOST']['RESELLER_LIST'];
		$this->data[$data['HOST']['HOST_NAME']] = $data['HOST'];

		return $this->data[$data['HOST']['HOST_NAME']];
	}

	function update($id)
	{
		$parameters = $this->getParams($id, $resellers_assgn, $resellers_reassgn);

		if($parameters['sb_ftp_host_fst'] && $parameters['sb_ftp_host_sec'])
			$err = $this->send_command("update_host_range", $parameters);
		else
			$err = $this->send_command("update_host", $parameters);
		
		if(!$err)
		{
			if($resellers_assgn) $this->send_command("assign_resellers", $resellers_assgn);
			if($resellers_reassgn) $this->send_command("deassign_resellers", $resellers_reassgn);
		}
		return $err;
	}

	function add($id = NEW_ID)
	{
		$parameters = $this->getParams($id, $resellers_assgn, $resellers_reassgn);

		if($parameters['sb_ftp_host_fst'] && $parameters['sb_ftp_host_sec'])
			$err = $this->send_command("add_host_range", $parameters);
		else 
			$err = $this->send_command("add_host", $parameters);
		
//		if(!$err) {
//				if($resellers_assgn) $err = $this->send_command("assign_resellers", $resellers_assgn);
//		}
		return $err;
	}

	function getParams($id, &$resellers_assgn, &$resellers_reassgn)
	{
		$par = &$this->data[$id];

		// resellers
		if(is_array($par['RESELLER_LIST'])) $new = array_keys($par['RESELLER_LIST']);
		if(is_array($par['RESELLERS_OLD'])) $old = array_keys($par['RESELLERS_OLD']);
		
		if(isset($id) && $id != NEW_ID)
		{
			if($par['sb_ftp_host_fst'] && $par['sb_ftp_host_sec'])
				$parameters = array('sbra_hosts_range_name' => $id);
			else 
			{
				$parameters = array(
							'sbra_hosts' => $id
				);
			}
			
			$reassgn = implode(',',array_diff((array)$old, (array)$new));
			if($reassgn) 
			{
				$resellers_reassgn['sb_resellers'] = $reassgn;
				$resellers_reassgn['sbra_hosts'] = $par['HOST_NAME'];
			}
		}

		$assgn = implode(',',array_diff((array) $new, (array) $old));		
		
		if($assgn)
		{
			$resellers_assgn['sb_resellers'] = $assgn;
			$resellers_assgn['sbra_hosts'] = $par['HOST_NAME'];
		}
		
		if($par['sb_ftp_host_fst'] && $par['sb_ftp_host_sec'])
		{
			$parameters = array_merge((array)$parameters, array(
				'sb_active' => $par['ACTIVE'],
				'sb_ftp_host_fst' => $par['sb_ftp_host_fst'],
				'sb_ftp_host_sec' => $par['sb_ftp_host_sec']
			));
		}
		else 
		{
			$parameters = array_merge((array)$parameters, array(
			 	'sb_ftp_host' => $par['HOST_NAME'],
			 	'sb_active' => $par['ACTIVE'],
			 	));
		} 	
		
		return $parameters;
	}
	
	function set_error($error)
	{
		switch($error['CODE'])
		{
			case '060009':
				parent::set_status($error);
			break;

			case '060004' :
				parent::set_status($error);
			break;
			
			case '060033':
				parent::set_status($error);
			break;
			
			default:
				parent::set_error($error);
		}
	}
}

function get_host_list()
{
	$list = new RA_Hosts();
	$list->getList();
	if(!$list->error())
	{
		foreach ($list->list as $item)
		{
			$res[$item['HOST_NAME']] = $item['HOST_NAME'];
		}
		return $res;
	}
}

class RA_Skins extends RA_List
{
	function RA_Skins()
	{
		parent::RA_List("skin.php");
	}

	function getList()
	{
		return parent::getList("get_skins");
	}
	
	function getCurrent()
	{
		return RA_List::_getCurrent("get_current_skin", "ID");
	}
	
	function setCurrent($id)
	{
		return RA_List::setCurrent("set_skin", "skin", $id);
	}
	
	function activate($ids)
	{
		return parent::activate("skins", $ids, "activate_skins");
	}

	function deactivate($ids)
	{
		return parent::deactivate("skins", $ids, "deactivate_skins");
	}
	
	function delete($ids)
	{
		return parent::delete("skins", $ids, "delete_skins");
	}

	// ??? where is in API
	function add($post)
	{
	//	return parent::add('add_host', $post);
	}
}

function get_skin_list()
{
	$list = new RA_Skins();
	$list->getList();
	if(!$list->error())
	{
		foreach ($list->list as $item)
		{
			if($item['ACTIVE'] == 1) $res[$item['ID']] = $item['CAPTION'];
		}
		return $res;
	}
}

class RA_Langs extends RA_List
{
	function RA_Langs()
	{
		parent::RA_List("lang.php");
	}
	
	function getList()
	{
		RA_List::getList("get_langs");
	}
	
	function getCurrent()
	{
		return RA_List::_getCurrent("get_current_lang", "ID");
	}
	
	function setCurrent($id)
	{
		return RA_List::setCurrent("set_lang", "lang", $id);
	}
	
	function delete($ids)
	{
		return parent::delete("langs", $ids, "delete_langs");
	}
}

function get_lang_list()
{
	$list = new RA_Langs();
	$list->getList();
	if(!$list->error())
	{
		foreach ($list->list as $item)
		{
			$res[$item['ID']] = $item['CAPTION'];
		}
		return $res;
	}
}

class RA_Templates extends RA_AdvList  
{
	function RA_Templates()
	{
		parent::RA_AdvList("templates.php");
	}

	function getList()
	{
		return parent::getList("get_templates");
	}
	
	function activate($ids)
	{
		return parent::activate("templates", $ids);
	}

	function deactivate($ids)
	{
		return parent::deactivate("templates", $ids);
	}
	
	function delete($ids)
	{
		return parent::delete("templates", $ids);
	}
}

class RA_Modules extends RA_AdvList  
{
	function RA_Modules()
	{
		parent::RA_AdvList("modules.php");
	}

	function getList()
	{
		return parent::getList("get_modules");
	}
	
	function activate($ids)
	{
		return parent::activate("modules", $ids);
	}

	function deactivate($ids)
	{
		return parent::deactivate("modules", $ids);
	}
	
	function delete($ids)
	{
		return parent::delete("modules", $ids);
	}
}

class RA_Plans extends RA_AdvList  
{
	function RA_Plans()
	{
		parent::RA_AdvList("plans.php");
	}

	function getList()
	{
		return parent::getList("get_plans");
	}
	
	function activate($ids)
	{
		return parent::activate("plans", $ids);
	}

	function deactivate($ids)
	{
		return parent::deactivate("plans", $ids);
	}
	
	function delete($ids)
	{
		return parent::delete("plans", $ids);
	}

	function set_for_trial_sites($ids)
	{
		$this->send_command('set_for_trial_sites', array('plans' => $ids));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}

	function unset_for_trial_sites($ids)
	{
		$this->send_command('unset_for_trial_sites', array('plans' => $ids));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}
	
	function process($post = null)
	{
		$post = $this->getPost($post);
		if($post['id_activate']) 
		{
			$ids = $post['id_activate'];
			switch ($post['com'])
			{
				case 1010 :
					$this->set_for_trial_sites($ids);
				break;

				case 1011 :
					$this->unset_for_trial_sites($ids);
				break;
				
				default:
					parent::process($post);
			}
		}
	
	}
	
	function update($id)
	{
		$par = &$this->plan[$id];
		
		$parameters = array(
				'plans' => $id,
				'sb_plan_name' => $par['NAME'],
				'sb_active' => $par['ACTIVE'],
		 		'sb_page_num' => $par['PAGES_NUMBER'],
		 		'sb_plan_desc' => sbm_strip_slashes($par['DESCRIPTION']),
		 		'PlanHost' => implode(',', array_keys($par['HOSTS'])),
		 		'PlanTempl' => implode(',', array_keys($par['TEMPLATES'])),
		 		'PlanMod' => implode(',', array_keys($par['MODULES'])),
		 		'sb_apply_to_all' => $par['sb_apply_to_all']
	 	);

		$this->send_command("update_plan", $parameters);
	}

	function add($id = NEW_ID)
	{
		$par = &$this->plan[$id];
		
		$parameters = array(
				'plans' => $id,
				'sb_plan_name' => $par['NAME'],
				'sb_active' => $par['ACTIVE'],
		 		'sb_page_num' => $par['PAGES_NUMBER'],
		 		'sb_plan_desc' => sbm_strip_slashes($par['DESCRIPTION']),
		 		'PlanHost' => implode(',', array_keys($par['HOSTS'])),
		 		'PlanTempl' => implode(',', array_keys($par['TEMPLATES'])),
		 		'PlanMod' => implode(',', array_keys($par['MODULES'])),
	 	);

		$this->send_command("create_plan", $parameters);
	}
	
	function get_details($id)
	{
		return $this->send_command("get_plan_details", array('plans' => $id));
	}
	
	function parse_details()
	{
		$plan = parse_responce($this->result, array('HOST' => 'HOST_NAME', 'MODULE' => 'NAME', 'TEMPLATE' => 'ID'));
		$this->plan[$plan['PLAN']['NAME']] = $plan['PLAN'];
		return $this->plan[$plan['PLAN']['NAME']];
	}

	function set_error($error)
	{
		switch($error['CODE'])
		{
			// Plan has been created
			case '050008' :
				parent::set_status($error);
			break;
			// Plan has been updated.
			case '050009' :
				parent::set_status($error);
			break;
			// OK
			case '050010' :
				parent::set_status($error);
			break;
			// Plan(s) have been activated
			case '050022' :
				parent::set_status($error);
			break;
			//Plan(s) have been deactivated.
			case '050023' :
				parent::set_status($error);
			break;
			// Plan for trial sites has been successfully set.
			case '050027' :
				parent::set_status($error);
			break;
			// Plan for trial sites has been successfully unset. The access for trial sites is denied.
			case '050029' :
				parent::set_status($error);
			break;
			// Plan(s) have been deleted.
			case '050030' :
				parent::set_status($error);
			break;
			
			default:
				parent::set_error($error);
		}
	}
}

function get_plan_list($only_trial = false)
{
	$res = null;
	$list = new RA_Plans();
	$list->getList();
	if(!$list->error())
	{
		foreach ($list->list as $item)
		{
			if(($item['ACTIVE'] == 1) && ($_SESSION['server']['username'] == $item['OWNER']) && (!$only_trial || $item['FOR_TRIAL_SITES'] == 'yes' || $item['BASE_PLAN'] == 'yes')) 
			{ 
			    $res[$item['NAME']] = $item['NAME'];
			    if($item['BASE_PLAN'] == 'yes') $baseplan = $item['NAME'];
			}
		}
		if($only_trial && sizeof($res) > 1) 
		{
			unset($res[$baseplan]);
		}
		
		return $res;
	}
}

class RA_Sites extends RA_AdvList
{
	function RA_Sites()
	{
		parent::RA_AdvList("sites.php");
	}

	function getList()
	{
		return parent::getList("get_sites");
	}
	
	function activate($ids)
	{
		return parent::activate("ids", $ids);
	}

	function deactivate($ids)
	{
		return parent::deactivate("ids", $ids);
	}
	
	function delete($ids)
	{
		return parent::delete("ids", $ids);
	}
	
	function trialtoregular($ids)
	{
		$this->send_command('trial2regular', array('ids' => $ids));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}
	
	function allow_publish($ids)
	{
		$this->send_command('allow_publish', array('ids' => $ids));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}	
	
	function deny_publish($ids)
	{
		$this->send_command('deny_publish', array('ids' => $ids));
		if($this->error()) 
		{
			return false;
		}

		return true;
	}	
	
	function process($post = null)
	{
		$post = $this->getPost($post);
		if($post['id_activate']) 
		{
			$ids = substr($post['id_activate'], 0, -1);
			switch ($post['com'])
			{
				case 1004 :
					$this->trialtoregular($ids);
				break;

				case 1005 :
					$this->deny_publish($ids);
				break;
				
				case 1006 :
					$this->allow_publish($ids);
				break;
				
				default:
					parent::process($post);
			}
		}
	
	}
	
	function get_details($id)
	{
		$res = $this->send_command("get_site_details", array('sb_siteid' => $id));
		return $res;
	}
	
	function parse_details()
	{
//		if(is_subclass_of($this->result, 'DomNode'))
//		{
		if (!$this->error()){
				$nodes = $this->result->get_elements_by_tagname('SITE');
				$site = $nodes[0];
					if($site->has_attributes())
					{
						foreach ($site->attributes() as $attribute)
						{
							$attributes[$attribute->name()] = $attribute->value();
						}
					}
					$res = $attributes;
				
			// plan
			$nodes = $this->result->get_elements_by_tagname('SITE_PLAN');
			$plan = $nodes[0];
	
		$this->site[$res['SITE_ALIAS']] = $res;
			$this->site[$res['SITE_ALIAS']]['SITE_PLAN'] = parse_responce($plan, array('HOST' => 'HOST_NAME', 'MODULE' => 'NAME', 'TEMPLATE' => 'ID'));
//		}
		return $res;
		}
	}
	
	function update($id)
	{
		$parameters = $this->getParams($id);
		$this->send_command("update_site", $parameters);
	}

	function add($id = NEW_ID)
	{
		$parameters = $this->getParams($id);

		$this->send_command("create_site", $parameters);
	}
	
	function getParams($id)
	{
		$par = &$this->site[$id];
		
		if(isset($id) && $id != NEW_ID)
		{
			$parameters = array(
				'sb_old_siteid' => $id
			);
		}
		else
		{
			$parameters = array(			
		 		'sb_site_type' => $par['TYPE']
			);
		}
		
		$parameters = array_merge((array)$parameters, array(
		 	'sb_siteid' => $par['SITE_ALIAS'],
		 	'sb_active' => $par['ACTIVE'],
		 	'sb_language' => $par['LANGUAGE'],
		 	));

			if(isset($par['RESELLER']) && $par['RESELLER']!='')
			{
				$parameters = array_merge($parameters,	array('sb_reseller' => $par['RESELLER']));
			}
			
	 		$parameters = array_merge((array)$parameters,
			 array(	'sb_send_mail' => $par['SEND_MAIL'],
	 				'sb_email' => $par['EMAIL'])
	 		);
			
			if($par['PSWD'] != PASSWD_NULL && $par['PSWD'] == $par['PSWD_CONF'])
			{
			 	$parameters['sb_pswd'] = $par['PSWD'];
			 	$parameters['sb_pswd_conf'] = $par['PSWD_CONF'];
			}

		 	if(strcasecmp($par['TYPE'],'TRIAL') != 0)
		 	{
		 		if(strpos($par['PLAN'], ', Revision') === false) $parameters['sb_plan'] = $par['PLAN'];
		 		
		 		if($par['MODE'] == 'ftp')
		 		{
		 			$parameters = array_merge((array)$parameters,
		 				array(
					 	'sb_publish' => $par['PUBLISH'],
					 	'sb_host_name' => $par['SITE_HOST_NAME'],
					 	'sb_mode' => $par['MODE'],
					 	'sb_page_num' => $par['PAGES_NUMBER'],
						'sb_ftp_host' => $par['FTP_HOST'],
						'sb_ftp_login' => $par['FTP_LOGIN'],
						'sb_ftp_workdir' => $par['FTP_WORK_DIRECTORY'],
						)
		 			);

//		 			if($par['FTP_PASS'] != PASSWD_NULL)
//		 			{
		 				$parameters['sb_ftp_pass'] = $par['FTP_PASSWORD'];
//		 			}
		 		}
		 		elseif($par['MODE'] == 'vps')
		 		{
		 			$parameters = array_merge((array)$parameters,
		 				array(
						'sb_domain' => $par['DOMAIN'],
						'sb_service_ve_ip' => $par['SERVICE_VE_IP'],
						'sb_vps_id' => $par['VPS_ID'],
						'sb_vps_workdir' => $par['VPS_WORKDIR'],
						'sb_vps_user' => $par['VPS_USER'],
						'sb_vps_group' => $par['VPS_GROUP']
						)
					);
		 		}
		 	$parameters = array_merge((array)$parameters, array(
		 		'sb_page_num' => $par['SITE_PLAN']['PAGES_NUMBER'],
		 		'PlanHost' => implode(',', array_keys($par['SITE_PLAN']['HOSTS'])),
		 		'PlanTempl' => implode(',', array_keys($par['SITE_PLAN']['TEMPLATES'])),
		 		'PlanMod' => implode(',', array_keys($par['SITE_PLAN']['MODULES'])),
		 		)
		 	);
		 }
		 return $parameters;
	}

	function set_error($error)
	{
			switch($error['CODE'])
			{
				// Site has been created. Site information has been successfully sent to the site owner.
				case '010082' :
					parent::set_status($error);
				break;
				// Site has been created.
				case '010048' :
					parent::set_status($error);
				break;
				// Site has been updated. Site information has been successfully sent to the site owner.
				case '010083' :
					parent::set_status($error);
				break;
				// Site has been updated.
				case '010051' :
					parent::set_status($error);
				break;
				// Site has been created. Error occurred when sending site information to the site owner.
				case '010047' :
					parent::set_status($error);
				break;
				// Site has been updated. Error occurred when sending site information to the site owner.
				case '010050' :
					parent::set_status($error);
				break;
				// Site(s) have been deleted.
				case '010056' :
					parent::set_status($error);
				break;
				// OK
				case '010081 ' :
					parent::set_status($error);
				break;
				// Site(s) has been published
				case '010054' :
					parent::set_status($error);
				break;
				// Update is not required.
				case '010075' :
					parent::set_status($error);
				break;
				// Site(s) have been activated.
				case '010079' :
					parent::set_status($error);
				break;
				// Site(s) have been deactivated.
				case '010078' :
					parent::set_status($error);
				break;
				// Publishing has finished successfully.
				case '010068' :
					parent::set_status($error);
				break;
				// Type has been changed successfully. You can add publishing parameters for these sites 
				case '010076' :
					parent::set_status($error);
				break;
				
				default:
					parent::set_error($error);
			}
	}
}

class RA_Resellers extends RA_AdvList  
{
	function RA_Resellers()
	{
		parent::RA_AdvList("resellers.php");
	}

	function getList()
	{
		return parent::getList("get_resellers");
	}
	
	function activate($ids)
	{
		return parent::activate("ids", $ids);
	}

	function deactivate($ids)
	{
		return parent::deactivate("ids", $ids);
	}
	
	function delete($ids)
	{
		return parent::delete("ids", $ids);
	}
	
	function update($id)
	{
		$parameters = $this->getParams($id);

		$this->send_command("update_reseller", $parameters);
	}

	function add($id = NEW_ID)
	{
		$parameters = $this->getParams($id);

		$this->send_command("create_reseller", $parameters);
	}
	
	function getParams($id)
	{
		$par = &$this->data[$id];
		
		if(isset($id) && $id != NEW_ID)
		{
			$parameters = array(
						'sb_reseller' => $id
			);
		}
		
		$parameters = array_merge((array)$parameters, array(
		 	'sb_domain' => $par['DOMAIN'],
		 	'sb_email' => $par['EMAIL'],
		 	'sb_name' => $par['NAME'],
		 	'sb_login' => $par['LOGIN'],
		 	'sb_skin' => $par['SKIN'],
		 	'sb_language' => $par['LANGUAGE'],
		 	'sb_limit_sites' => $par['LIMIT_SITES'] == '' ? '-1' : $par['LIMIT_SITES'] ,
			'sb_limit_hosts' => $par['LIMIT_HOSTS'] == '' ? '-1' : $par['LIMIT_HOSTS']
		 	// ....
		 	));
		if($par['PSWD'] != PASSWD_NULL && $par['PSWD'] == $par['PSWD_CONF']) 
		{
		 	$parameters['sb_pswd'] = $par['PSWD'];
		 	$parameters['sb_pswd_conf'] = $par['PSWD_CONF'];
		}

		// Bug 62789 workaround !!!
		    $parameters = array_merge((array)$parameters, array(
		    	'Hosts' => is_array($par['HOSTS']) ? implode(',', (array)array_keys(array_filter($par['HOSTS'], array($this, 'filter_hosts_on_owner')))) : '')
			);


		return $parameters;
	}
	
	function filter_hosts_on_owner($a)
	{
		return $a['OWNER'] == $GLOBALS['server']['username'] || sizeof($a) == 1;
	}
	
	function get_details($id)
	{
		return $this->send_command("get_reseller_details", array('sb_reseller' => $id));
	}
	
	function parse_details()
	{
		$data = parse_responce($this->result, array('HOST' => 'HOST_NAME', 'PLAN' => 'NAME', 'SITE' => 'SITE_ALIAS'));
		$this->data[$data['RESELLER']['LOGIN']] = $data['RESELLER'];

		return $this->data[$data['RESELLER']['LOGIN']];
	}

	function set_error($error)
	{
		switch($error['MESSAGE'])
		{
			case 'Reseller(s) have been added successfully.' :
				parent::set_status($error);
			break;

			case 'Reseller(s) have been updated successfully.' :
				parent::set_status($error);
			break;
			
			default:
				parent::set_error($error);
		}
	}
}

function get_reseller_list()
{
	$list = new RA_Resellers();
	$list->getList();
	if(!$list->error())
	{
		foreach ($list->list as $item)
		{
			$res[$item['LOGIN']] = $item['NAME'] . ' - (' . $item['LOGIN'] . ')';
		}
		return $res;
	}
}


class RA_Account extends RA_Responce
{
	var $script;
	
	function RA_Account()
	{
		parent::RA_Responce("account.php");
	}

	function set($user, $passwd, $passwd_confirm)
	{
		parent::send_command("change_login", array('login' => $user, 'password' => $passwd, 'password_confirm' => $passwd_confirm));

		if(!$this->error())
		{
			return true;
		}
	}
}
?>
